;APS000011E60000A61900013A6A00000EA5000000000000000000000000000000000000000000000000
;==============================================================
;==============================================================
;==============================================================
;==============================================================
;==============================================================
;
;
;
;
;           I N I T   +   F R E E    R O U T I N E N
;
;
;
;
;
;==============================================================
;==============================================================
;==============================================================
;==============================================================
;==============================================================


;==============================================================
;=== Keyfile-code:
;=== 
;===   keyfile decoding:
;===     InitSomething (right behind the lib-openings)
;=== 
;===   checksum-JSRs:		code in:
;===     InitVarsOnce		mt-prefs.s
;===     cli_args_and_tooltypes	mt-arexx.s
;===   
;===   copy author's name:
;===     (This routine must be called after all checksum checkings.)
;===     InitNewData (called if a new song is initiated)
;===   
;===   gadget-/menu-/rawkey-fixes:
;===   (These routines must be called after all checksum checkings.)
;===     Localization		songlength minus button
;===     v37_workaround		songlength plus button
;===     xpk_init		songlength integer
;===     CreateARexxPort	remapper menuitem, delete-position button
;===     OpenSerial		midifilter menuitem, insert-position button
;===     InitBitmaps		remapper rawkey, midifilter rawkey
;===     
;===   





;==============================================================
;=== OS3.0 Features: (siehe "V39")
;=== 
;=== Menu-Hotkey-Commstrings (CommKeys + Flag werden bei V37 gelscht)
;=== SetWindowPointerA() (durch SetPointer() und ClearPointer() ersetzt)
;=== NewLookMenus (Tags werden von V37 ignoriert)
;=== GT_GetGadgetAttrsA() (durch eigene Routinen ersetzt)
;=== GadgetHelp, HelpControl() (ist disabled, wenn pre-V39)
;=== SetABPenDrMd()
;=== GTNM_Front/BackPen Tags
;=== 
;=== 
;==============================================================




InitSomething

;=== BSS section is automatically cleared by LoadSeg()

;=== BSS lschen
;	lea	bss_start,a0
;	moveq	#0,d0
;	move.l	#bss_len,d1
;.clr	move.b	d0,(a0)+
;	subq.l	#1,d1
;	bne.s	.clr

	move.l	$4.w,(a5)
	bsr	init_tables

	suba.l	a1,a1
	move.l	(a5),a6
	jsr	FindTask(a6)
	move.l	d0,mytask(a5)




	st	reply_sig(a5)

	st	audiosignal(a5)
	st	scoper2main_sig(a5)
;	st	answer_sig(a5)




;=== is the 68020 version of MT running on a 68020-amiga ?
	IFNE	mc68020
	move.w	$128(a6),d0
	btst	#1,d0
	beq	.neg			; machine has no 68020
	ENDC



;=== check kickstart version
	cmp.w	#39,$14(a6)
	scc	kick30(a5)
;	sf	kick30(a5)



;=== are we clicked from wb ?
	IFNE	executable
	move.l	mytask(a5),a0
	tst.l	$ac(a0)
	bne.s	.fromcli

	lea	$5c(a0),a0
	move.l	a0,-(sp)
	jsr	WaitPort(a6)
	move.l	(sp)+,a0
	jsr	GetMsg(a6)
	move.l	d0,wbenchmsg(a5)
.fromcli
	ENDC




;=== misc signals
	moveq	#-1,d0
	jsr	AllocSignal(a6)
	move.b	d0,reply_sig(a5)
	bmi	.neg

	moveq	#-1,d0
	jsr	AllocSignal(a6)
	move.b	d0,replayoutput_sig(a5)
	bmi	.neg

	jsr	CreateMsgPort(a6)
	move.l	d0,todo_port(a5)
	beq	.neg




;=== Smtliche Libraries ffnen
	lea	libraries(pc),a2
	moveq	#libsnum-1,d7
.libloop
	moveq	#0,d0
	move.w	(a2)+,d0		; Version
	move.l	a2,a1
	adda.w	(a2)+,a1		; Offset zu Libname
	jsr	OpenLibrary(a6)
	move.w	(a2)+,d1		; base-Offset
	move.w	(a2)+,d2		; required-flag
	move.l	d0,(a5,d1.w)
	bne.s	.opened
	tst.w	d2
	bne	.neg			; lib is required
.opened	dbf	d7,.libloop



	bsr	OpenTimer_main
	beq	.neg


	bsr	load_catalog

	bsr	.double_test
	beq	.doubletask


	IFNE	keyfile_active
	jsr	decode_keyfileJ(a5)
	ENDC



	bsr	InitVarsOnce		; call this to initialize defaults
	beq	.neg
	bsr	cli_args_and_tooltypes	; call this BEFORE loadprefs, because
	beq	.neg			; this changes the current dir

	jsr	loadprefs_routineJ(a5)	; call this after InitVarsOnce
					; but before cli_args_... to make sure
					; that args/tooltypes override prefs.
	bsr	check_args_and_tooltypes ; call this after loadprefs

	jsr	check_titleflagsJ(a5)




	bsr	PrepareCIA
	beq	.neg

	bsr	LaunchMidiProcess
	beq	.neg
	bsr	LaunchPlayerProcess
	beq	.neg

	bsr	LaunchScoper
	beq	.neg

	bsr	CreateArexxPort		; call this AFTER loadprefs
	beq	.neg

	bsr	InitBitmaps
	beq	.neg

	IFNE	keyfile_active
	jsr	decode_complex_eorJ(a5)
	ENDC

	bsr	xpk_init
	bsr	Localization
	bsr	v37_workaround

	bsr	InitNewData		; call this AFTER AllocWorktracks (?)
	beq	.neg
;	jsr	CloseChannelwindowsJ(a5)


	IFNE	keyfile_active
	move.l	keybas(a5),d0
	beq.s	.nokey4
	move.l	d0,a6
	lea	len_plus_downD(a5),a0
	move.l	MainGadgetDownTabD(a5),a1
	moveq	#len_plus_down_num,d0
	jsr	keyFixGadgetDown(a6)
.nokey4
	ENDC


	tst.l	iconify(a5)
	bne.s	.noscreen
	jsr	setupscreenJ(a5)
	beq	.neg
.noscreen

	bsr	SetupIDCMP
	beq	.neg


	IFNE	keyfile_active
	lea	keybas+4(a5),a0
	move.l	-(a0),d0
	beq.s	.nokey3
	move.l	d0,a6
	lea	len_minus_downD(a5),a0
	move.l	MainGadgetDownTabD(a5),a1
	moveq	#len_minus_down_num,d0
	jsr	keyFixGadgetDown(a6)
.nokey3
	ENDC



	bsr	load_controlsources


	IFNE	keyfile_active
	move.l	keybas(a5),d0
	beq.s	.nokey
	move.l	d0,a6
	lea	midifilter_menuD(a5),a0
	move.l	toolsmenuTabD(a5),a1
	moveq	#midifilter_menu_id,d0
	move.l	MTmainNewMenu0D(a5),a2
	lea	MTmainNMfilter(a2),a2
	jsr	keyFixMenu(a6)
.nokey
	ENDC



	bsr	load_quickloader

	IFNE	keyfile_active
	lea	keybas-8(a5),a0
	move.l	8(a0),d0
	beq.s	.nokey2
	move.l	d0,a6
	lea	ins_buttonD(a5),a0
	moveq	#GD_ins,d0
	move.l	MainGadgetUpTabD(a5),a1
	jsr	keyFixGadget(a6)
.nokey2
	ENDC



	tst.l	iconify(a5)
	beq.s	.uniconified
	jsr	do_iconifyJ(a5)
	beq.s	.neg
	bra.s	.further
.uniconified
	jsr	OpenAllWindowsJ(a5)
	beq.s	.neg
	jsr	show_aboutJ(a5)
.further


	move.b	changeserial_sig(a5),d1
	bmi.s	.noser
	jsr	main2midiprocess_signalJ(a5)
	bne.s	.ser_ok
.noser	jsr	noserialJ(a5)
.ser_ok


	POSITIV



;=== MidiTracker already running ?

.double_test	; returns: pos = mt not already running, neg = mt already running
		;          d1 = mt-task if already running

;	move.l	mytask(a5),a0
;	move.l	$a(a0),oldtaskname(a5)	; clear taskname to avoid
;	clr.l	$a(a0)			; MT detecting itself

	move.l	(a5),a6
	jsr	Forbid(a6)
	move.l	pubnameD(a5),a1
;	jsr	FindTask(a6)
	jsr	FindSemaphore(a6)
	move.l	d0,d2
	jsr	Permit(a6)
	tst.l	d2
	bne.s	.neg

;=== Change taskname to a unique name. When running MT a second time,
;=== first MT can receive ^D to uniconify.
;	move.l	mytask(a5),a0
;	move.l	pubnameD(a5),$a(a0)

	lea	maintask_semaphore(a5),a1
	move.l	pubnameD(a5),$a(a1)
	jsr	AddSemaphore(a6)

	lea	maintask_semaphore(a5),a0
	jsr	ObtainSemaphore(a6)

	POSITIV
.neg	move.l	d2,a0
	move.l	$28(a0),d1
	NEGATIV




.doubletask
	move.l	d1,-(sp)		; old MT process

	move.w	#loc_mtrunning,d0
	bsr	getcatstring
	move.l	a1,-(sp)

	move.w	#loc_grabit,d0
	bsr	getcatstring
	move.l	a1,a3

	move.w	#loc_donothing,d0
	bsr	getcatstring
	move.l	a1,a2

	move.l	(sp)+,a1
	jsr	SysRequestJ(a5)
	tst.l	d0
	beq.s	.fix

	move.l	pubnameD(a5),a0
	move.l	intbas(a5),a6
	jsr	LockPubScreen(a6)
	tst.l	d0
	beq.s	.uniconify
	move.l	d0,a0
	jsr	ScreenToFront(a6)
	move.l	pubnameD(a5),a0
	jsr	UnlockPubScreen(a6)

.fix	addq.w	#4,sp
	bra.s	.neg

.uniconify
	move.l	(sp)+,a1
	move.l	#$2000,d0		; ^D = uniconify
	move.l	(a5),a6
	jsr	Signal(a6)
	bra.s	.neg






InitVarsOnce	; Variablen, die nur beim Start initialisiert werden

	move.l	serialoutpufferD(a5),a0
	move.l	a0,irqptr_out(a5)
	move.l	a0,writeptr_out(a5)
	lea	serialoutsize(a0),a0
	move.l	a0,upperlimit_out(a5)

	move.l	serialinpufferD(a5),a0
	move.l	a0,readptr_in(a5)
	move.l	a0,irqptr_in(a5)
	lea	serialinsize(a0),a0
	move.l	a0,upperlimit_in(a5)


	IFNE	keyfile_active
	jsr	decode_number_of_bitsJ(a5)
	ENDC


	move.l	#sysexbuffer1,sysexbuffers(a5)
	move.l	#sysexbuffer2,sysexbuffers+4(a5)

	st	autovelflag(a5)
	st	metroflag(a5)
	st	scaledrec(a5)
	st	cuttobuf(a5)
;	st	sp_cuttobuf(a5)
;	st	dump_handshake(a5)
	st	autorewind(a5)


	st	sequencer_sysex(a5)
	st	midithru_global(a5)

	move.b	#72,metronote(a5)	; C-5
	move.b	#100,metrovel(a5)
	move.w	#$100+98,metropreset(a5)
	move.w	#24,metrostep(a5)
	move.w	#2,metrobars(a5)
	move.b	#16,metrochannel(a5)
	move.w	#60,metrootherbeats(a5)
	moveq	#recbufsize_def,d0
	move.l	d0,recbufsize(a5)
	lsl.l	#8,d0
	lsl.l	#2,d0
	move.l	d0,recbufsizebytes(a5)
	move.b	#64,oldfixvelocity(a5)
	move.b	#112,firstautovel(a5)
	move.b	#112,lockvelint(a5)

	moveq	#4,d0
	move.w	d0,metrobeats(a5)
	move.l	d0,pattsizedelta(a5)

	moveq	#1,d0
	move.l	d0,quantize(a5)
	move.b	d0,pastemode(a5)
	move.b	d0,metrotype(a5)
	move.w	d0,startchannel(a5)
	move.w	d0,transchannel(a5)
	move.w	d0,auditionpasses(a5)

	moveq	#10,d0
	move.l	d0,sysexdelay(a5)

;	moveq	#40,d0
;	move.l	d0,midipri(a5)

;	move.l	#44100,samplerate(a5)
;	move.b	#8,samplebits(a5)
	moveq	#def_maxtracks,d0
	move.l	d0,pr_maxtracks(a5)
;	bsr	make_maxtracks

	moveq	#25,d0
	move.l	d0,sc_xbevels(a5)
	moveq	#8,d0
	move.l	d0,sc_ybevels(a5)

	move.w	#4,gmbarsperpattern(a5)

;	clr.b	quadrafrom(a5)			; init quadrasynth variables
;	move.b	#127,quadrato(a5)

	move.l	#events_def/pattscale_def,defpatternsize(a5)

	moveq	#pattscale_def,d0
;	move.l	d0,highresoint(a5)
	move.l	d0,defreso(a5)
	move.w	#octave_def,octave(a5)

;	moveq	#-1,d0
;	move.l	d0,sp_rangestart(a5)

	sf	mpress_or_ppress(a5)

	lea	actions_mnotes(a5),a0
	move.b	#90,(a0)+			; f#6
	move.b	#91,(a0)+			; g-6
	move.b	#92,(a0)+			; g#6
	move.b	#93,(a0)+			; a-6
	move.b	#94,(a0)+			; a#6
	move.b	#95,(a0)+			; b-6
	move.b	#96,(a0)+			; c-7



	clr.l	pr_displayid(a5)



;=== Default-ARexxportname kopieren
	lea	arexxport_def(pc),a0
	lea	arexxportname(a5),a1
	COPYTILLZERO



;=== Default Window-Koordinaten kopieren
	moveq	#1,d0
	move.l	d0,openwindows(a5)		; main window open

	lea	windowcoords(pc),a0
	lea	pr_main_ltwh(a5),a1
	moveq	#coordsnum-1,d0
.coordsloop
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbf	d0,.coordsloop


	lea	Iconify_coords(a5),a0
	move.w	#380,(a0)+
	move.w	#25,(a0)+


;	move.l	MTsprocStruct+wd_GTags(a5),a0
;	lea	rt_spload_name(a5),a1
;	move.l	a1,(a0)



	IFNE	keyfile_active
	jsr	decode_simple_eorJ(a5)
	ENDC


;=== Unique-ID fr Gadgethelp besorgen
	tst.b	kick30(a5)
	beq.s	.no39
	move.l	utilbas(a5),a6
	jsr	GetUniqueID(a6)		; V39
	move.l	d0,uniqueID(a5)
.no39


;=== Default XPK-Compressor = NONE
	sf	xpkonoff(a5)
	move.l	xpkcycleNoneD(a5),a0
	move.l	(a0),compressorID(a5)
	clr.w	compressor(a5)



;=== init Channelscope-Semaphore
	lea	chanscope_semaphore(a5),a0
	move.l	(a5),a6
	jsr	InitSemaphore(a6)




;=== init Program change listview-names
	lea	pchgNames(a5),a3
	move.l	pchgNode1D(a5),a4
	moveq	#1,d7
.nodeloop
	move.l	a3,a0
	move.l	d7,d0
	moveq	#1,d1
	jsr	decout_noleadJ(a5)
	move.b	#' ',(a0)

	move.l	a3,$a(a4)

	move.l	(a4),a4
	lea	pchgTypeMaxlen+4(a3),a3
	addq.w	#1,d7
	cmp.w	#16,d7
	bls.s	.nodeloop




;=== Check for slow amiga to suppress playback-output:
;=== Slow are: 68000, 68010, 68020 without fastmem.

	move.w	$128(a6),d0
	btst	#1,d0
	beq.s	.slow
; machine has 68020+
	btst	#2,d0
	bne.s	.fast
; machine has 68020 -> check fastmem

	moveq	#4,d1
	jsr	AvailMem(a6)
	tst.l	d0
	beq.s	.slow
.fast	st	pattout(a5)
.slow




	IFNE	keyfile_active
	jsr	decode_rotate_addJ(a5)
	ENDC


;=== allocate fib
	moveq	#2,d1
	move.l	dosbas(a5),a6
	jsr	AllocDosObject(a6)
	move.l	d0,fib(a5)
	beq.s	.neg




	POSITIV
.neg	NEGATIV






init_channelmaps
;=== init channel-map
	lea	channels_maps(a5),a0
	moveq	#1,d0
.maploop
	move.w	d0,(a0)+
	add.w	d0,d0
	bne.s	.maploop
	rts







NewMaxtracksData	; d0.l=new maxtracks
			; returns: positive = no change,
			;          negative = maxtracks-value has changed

	cmp.l	maxtracks(a5),d0
	bne.s	.change
	POSITIV				; positiv means, maxtracks hasn't changed

.change	moveq	#min_maxtracks,d1
	cmp.l	d1,d0
	bmi.s	.setval
	move.l	#max_maxtracks,d1
	cmp.l	d1,d0
	bls.s	.do
.setval	move.l	d1,d0

.do	bsr.s	ReAllocMaxtracksData
	bne.s	.nega

;=== we could not allocate new-maxtracks-data, so try now
;=== the old maxtracks value.

	move.l	maxtracks(a5),d0
	bsr.s	ReAllocMaxtracksData
	bne.s	.nega

;=== if even this fails, allocate the absolute minimum which MUST succeed.

	moveq	#def_displayed_tracks,d0
	move.l	d0,displayed_tracks(a5)
	bsr.s	ReAllocMaxtracksData
.nega	NEGATIV				; negative means, maxtracks has changed



PutMaxtracks	; d0 = maxtracks
	move.l	d0,maxtracks(a5)
	subq.l	#1,d0
	move.l	d0,maxtracks_m1(a5)
	rts





;=== allocate anything that deals with MAXTRACKS
;=== In order to do so, ensure that maxtracks(a5) still holds the old maxtracks
;=== value. Old allocations are released.


ReAllocMaxtracksData	; d0=new maxtracks value
			; returns: pos/neg for success/failure

			rsreset
;.sp_trackchanged	rs.l	1
;.sp_current_onoffs	rs.l	1
.sp_freetracks		rs.l	1
.sp_newmaxtracks	rs.l	1
.sp_recevents		rs.l	1
.sp_recevents_spare	rs.l	1
;.sp_playcounters	rs.l	1
;.sp_worktracks		rs.l	1
.sp_chordflags		rs.l	1
;.sp_current_states	rs.l	1
;.sp_chanc		rs.w	1
;.sp_csc			rs.w	1
.sp_note_tracking	rs.l	1

.sp_sizeof		rs.w	0


	cmp.l	maxtracks(a5),d0
	beq	.nonew


	lea	-.sp_sizeof(sp),sp
	move.l	d0,.sp_newmaxtracks(sp)

;=== trackchanged-flags
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_trackchanged(sp)
;	beq	.nomem1


;=== the current on/off-state flags for all tracks
;	move.l	.sp_newmaxtracks(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_current_onoffs(sp)
;	beq	.nomem2


;=== the current state flags for all tracks
;	move.l	.sp_newmaxtracks(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_current_states(sp)
;	beq	.nomem3


;=== freetracks-flags for recordings
	move.l	.sp_newmaxtracks(sp),d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_freetracks(sp)
	beq	.nomem4


;=== chord-flags for chordmode
	move.l	.sp_newmaxtracks(sp),d0
	move.l	#$10001,d1
	bsr	MyAllocVec
	move.l	d0,.sp_chordflags(sp)
	beq	.nomem5


;=== record-events
	move.l	.sp_newmaxtracks(sp),d0
	lsl.l	#2,d0		; = mulu #wd_sizeof,d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_recevents(sp)
	beq	.nomem6

;=== record-events spare
	move.l	.sp_newmaxtracks(sp),d0
	lsl.l	#2,d0		; = mulu #wd_sizeof,d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_recevents_spare(sp)
	beq	.nomem6a


;=== playcounters
;	moveq	#prec3,d0
;	move.l	active_csources(a5),d1
;	mulu	#pcc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_csc(sp)

;	move.l	.sp_newmaxtracks(sp),d1
;	mulu	#pc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_chanc(sp)
;	lsl.l	#4,d0

	move.l	.sp_newmaxtracks(sp),d0
	lsl.l	#5,d0			; 2 bytes per track, 16 channels
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_note_tracking(sp)
	beq	.nomem7


;=== note-worktracks
;	move.l	.sp_newmaxtracks(sp),d1
;	bsr	AllocNWorktracks
;	beq	.nomem8
;	move.l	d0,.sp_worktracks(sp)




;=== copy all required data

;	move.l	.sp_trackchanged(sp),a1
;	move.l	.sp_current_onoffs(sp),a3
;	move.l	.sp_current_states(sp),a6

;	move.l	a6,d0
;	bne.s	.docopy

;	move.l	.sp_newmaxtracks(sp),d0
;	subq.l	#1,d0
;.clear
;	clr.b	(a1)+
;	clr.b	(a3)+
;	clr.b	(a6)+
;	dbf	d0,.clear
;	bra.s	.copyok

;.docopy
;	move.l	trackchanged(a5),a0
;	move.l	current_onoffs(a5),a2
;	move.l	current_states(a5),a4

;	move.l	.sp_newmaxtracks(sp),d1
;	move.l	maxtracks(a5),d0
;	cmp.l	d1,d0
;	bcs.s	.copy
;	move.l	d1,d0
;.copy	subq.l	#1,d0
;.cloop
;	move.b	(a0)+,(a1)+
;	move.b	(a2)+,(a3)+
;	move.b	(a4)+,(a6)+
;	dbf	d0,.cloop
;.copyok



	bsr	FreeMaxtracksData



;	move.l	.sp_trackchanged(sp),trackchanged(a5)
;	move.l	.sp_current_onoffs(sp),current_onoffs(a5)
;	move.l	.sp_worktracks(sp),worktracks(a5)
	move.l	.sp_note_tracking(sp),note_tracking(a5)
;	move.w	.sp_chanc(sp),chanc(a5)
;	move.w	.sp_csc(sp),csc(a5)
	move.l	.sp_recevents(sp),recevents(a5)
	move.l	.sp_recevents_spare(sp),recevents_spare(a5)
	move.l	.sp_freetracks(sp),freetracks(a5)
	move.l	.sp_chordflags(sp),chordflags(a5)
;	move.l	.sp_current_states(sp),current_states(a5)
	move.l	.sp_newmaxtracks(sp),d0
	bsr	PutMaxtracks

	lea	.sp_sizeof(sp),sp
.nonew	POSITIV


;.nomem8
;	lea	.sp_note_tracking(sp),a0
;	bsr	MyFreeVector

.nomem7	lea	.sp_recevents_spare(sp),a0
	bsr	MyFreeVector

.nomem6a
	lea	.sp_recevents(sp),a0
	bsr	MyFreeVector

.nomem6	lea	.sp_chordflags(sp),a0
	bsr	MyFreeVector

.nomem5	lea	.sp_freetracks(sp),a0
	bsr	MyFreeVector

.nomem4
;	lea	.sp_current_states(sp),a0
;	bsr	MyFreeVector

;.nomem3
;	lea	.sp_current_onoffs(sp),a0
;	bsr	MyFreeVector

;.nomem2	lea	.sp_trackchanged(sp),a0
;	bsr	MyFreeVector

;.nomem1
	lea	.sp_sizeof(sp),sp
	NEGATIV






FreeMaxtracksData

;	lea	trackchanged(a5),a0
;	bsr	MyFreeVector

;	lea	current_onoffs(a5),a0
;	bsr	MyFreeVector

	lea	freetracks(a5),a0
	bsr	MyFreeVector

	lea	recevents(a5),a0
	bsr	MyFreeVector

	lea	recevents_spare(a5),a0
	bsr	MyFreeVector

	lea	note_tracking(a5),a0
	bsr	MyFreeVector

	lea	chordflags(a5),a0
	bsr	MyFreeVector

;	lea	current_states(a5),a0
;	bsr	MyFreeVector

;	bsr	FreeWorktracks

	moveq	#0,d0
	bra	PutMaxtracks





;=== Default-windowkoordinaten (gleiche Reihenfolge wie in prefs)

windowcoords
	dc.w	0,11,640,132		; main
	dc.w	64,68,528,160		; chan
	dc.w	72,10,503,244		; sproc
	dc.w	96,40,442,139		; metro
	dc.w	80,42,274,183		; editprefs
	dc.w	53,46,532,158		; pgfx
	dc.w	137,52,321,159		; sds
	dc.w	36,55,530,251		; score
	dc.w	126,57,217,150		; k2000
	dc.w	343,57,160,150		; quadrasynth
	dc.w	450,20,activity_width+19,activity_height+31 ; activity
	dc.w	10,10,536,98		; remap
	dc.w	80,42,510,132		; midiprefs
	dc.w	80,42,264,187		; sysprefs
	dc.w	100,50,328,129		; kact
	dc.w	150,50,315,159		; sysexed
	dc.w	0,50,632,112		; filter
	dc.w	100,50,240,150		; boehm
	dc.w	10,50,240,150		; mc303
	dc.w	300,50,140,150		; yamaha xg
	dc.w	300,50,140,200		; quasar
	dc.w	300,50,240,200		; yamaha cs1x
coordsnum = (*-windowcoords)/8




;=== All libraries to open on startup

; version, ^name (relative), base, required (0=no, 1=yes)

libraries
	dc.w	36,dosnam-*,dosbas,1
	dc.w	36,intnam-*,intbas,1
	dc.w	36,gadnam-*,gadbas,1
	dc.w	0,gfxnam-*,gfxbas,1
	dc.w	36,utilnam-*,utilbas,1
	dc.w	38,rtnam-*,rtbas,1
	dc.w	36,dfnam-*,dfbas,1
	dc.w	38,locnam-*,locbas,0
	dc.w	0,rxsysnam-*,rxsbas,0
	dc.w	2,xpknam-*,xpkbas,0
	dc.w	36,iconnam-*,iconbas,1
	dc.w	37,wbnam-*,wbbas,1
	IFNE	keyfile_active
	IFEQ	force_demo
	dc.w	0,keynam-*,keybas,0
	ENDC
	ENDC
	dc.w	41,cgxnam-*,cgxbas,0
;	dc.w	0,mtnam-*,mtbas,1
libsnum = (*-libraries)/8





dosnam		dc.b	'dos.library',0
utilnam		dc.b	'utility.library',0
intnam		dc.b	'intuition.library',0
gadnam		dc.b	'gadtools.library',0
rtnam		dc.b	'reqtools.library',0
gfxnam		dc.b	'graphics.library',0
dfnam		dc.b	'diskfont.library',0
locnam		dc.b	'locale.library',0
rxsysnam	dc.b	'rexxsyslib.library',0
		IFEQ	use_cia_b
cianam		dc.b	'ciaa.resource',0
		ELSE
cianam		dc.b	'ciab.resource',0
		ENDC
sernam		dc.b	'serial.device',0
timnam		dc.b	'timer.device',0
mtcatname	dc.b	'MidiTracker.catalog',0
arexxport_def	DC.B	'rexx_MT',0
prefsname_def	dc.b	'MidiTracker.prefs',0
xpknam		dc.b	'xpkmaster.library',0
iconnam		dc.b	'icon.library',0
wbnam		dc.b	'workbench.library',0
cgxnam		dc.b	'cybergraphics.library',0
;mtnam		dc.b	'miditracker.library',0

		IFNE	keyfile_active
		IFEQ	executable
keynam		dc.b	'mt:miditracker-key',0
		ELSE
keynam		dc.b	'PROGDIR:miditracker-key',0
		ENDC
		ENDC




;=== here comes the obligatory version-string

		dc.b	'$VER: MidiTracker '
		VERSION_STRING
		dc.b	' '
		PROCESSOR_STRING
		dc.b	' ('
		RELEASE_DATE_STRING
		dc.b	')',13,10,0


;=== Author-name, if not registered

CODECHAR	MACRO
		dc.b	((\1*$08)&$f8+(\1&$e0)/$20)~$ff
		ENDM


unknown_user
		CODECHAR 'T'
		CODECHAR 'i'
		CODECHAR 'm'
		CODECHAR 'e'
		CODECHAR ' '
		CODECHAR 't'
		CODECHAR 'o'
		CODECHAR ' '
		CODECHAR 'g'
		CODECHAR 'e'
		CODECHAR 't'
		CODECHAR ' '
		CODECHAR 'w'
		CODECHAR 'i'
		CODECHAR 'z'
		CODECHAR 'e'
		dc.b	0


		even





;=== wird von InitSomething und project_clear aufgerufen!
;=== und von load_mt und song_button/song_plus/song_minus

;=== initialisiert neuen song

InitNewData
	sf	songchanged(a5)
	move.w	#1,current_remap_channel(a5)
	clr.b	songheader+so_songname(a5)	; 1. Byte auf 0 setzen
	clr.b	rt_savemt_name(a5)		; 1. Byte auf 0 setzen



;=== prepare the author's name: retrieve the keyfile's username

	lea	songheader+so_author(a5),a0

	IFNE	keyfile_active
	move.l	keybas(a5),d0
	beq.s	.nokey
	move.l	d0,a6
	moveq	#authorsize-1,d0
	jsr	keyCopyAuthorsName(a6)
	bra.s	.filled
	ENDC

.nokey	lea	unknown_user(pc),a1
	bra.s	.jumpin
.decodeloop
	not.b	d0
	ror.b	#3,d0
	move.b	d0,(a0)+
.jumpin	move.b	(a1)+,d0
	bne.s	.decodeloop
	move.b	d0,(a0)
.filled


	bsr	init_channelmaps


	move.w	#127,mastervolume(a5)
	move.w	#def_bpm,tempo(a5)
	clr.l	looppos(a5)
	sf	loopsong(a5)
	sf	solomode(a5)



	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	movem.l	d0-d3,desttranss(a5)
	movem.l	d0-d3,pchgtypes(a5)


	move.l	pchg_togo_initsD(a5),a0
	move.b	(a0),d1
	lea	pchg_togo(a5),a1
	moveq	#15,d0
.pchgloop
	move.b	d1,(a1)+
	dbf	d0,.pchgloop



	jsr	NewControlsourcesJ(a5)
	beq	.neg


	move.l	pr_maxtracks(a5),d0
	bsr	ReAllocMaxtracksData
	beq	.neg




	clr.l	currentpos(a5)
	move.w	#1,currentchannel(a5)
	clr.w	channelglobalstates(a5)


;	bsr	init_currentcs_onoffs
;	bsr	init_current_onoffs



;=== positions allocieren
	moveq	#def_length,d0
	jsr	AllocPositionsJ(a5)
	beq	.neg

	move.l	length(a5),d0
	jsr	AllocPatterntabJ(a5)
	beq	.neg


;=== pattern 0 allocieren
	moveq	#0,d0
	move.l	d0,currentpattern(a5)
	jsr	AllocPatternJ(a5)
	beq	.neg
	jsr	CorrectPatternJ(a5)
;	jsr	CorrectChannelJ(a5)



	bsr	reset_channelnames
	bsr	InitChannelselectData
	jsr	make_selector_menuJ(a5)




	move.l	panic_codesD(a5),a1
	move.b	7(a1),d2
	lea	channelvolumes(a5),a0
	lea	channelsliders(a5),a1
	lea	channellevels(a5),a2
	moveq	#15,d0
	moveq	#127,d1
.fillloop
	move.b	d2,(a0)+
	move.b	d1,(a1)+
	move.b	d1,1(a2)	; velocity
	move.b	d1,3(a2)	; volume
	addq.w	#4,a2
	dbf	d0,.fillloop



	bsr.s	restore_filters



	POSITIV
.neg	NEGATIV




restore_filters
	lea	pr_filter_block_start(a5),a0
	lea	filter_block_start(a5),a1
	move.l	#pr_filter_block_end-pr_filter_block_start,d0
	move.l	(a5),a6
	jmp	CopyMem(a6)




default_channelvalues	; a0 = ^channelvalue-block

	clr.l	chan_displaytrack(a0)
	clr.l	chan_currenttrack(a0)
	clr.l	chan_eventpos(a0)
	clr.b	chan_vel_or_pp(a0)
	clr.w	chan_cursorpos(a0)

	moveq	#def_displayed_tracks,d0
	move.l	d0,chan_displayed_tracks(a0)
	moveq	#def_lines_in_td_half,d0
	move.l	d0,chan_lines_in_td_half(a0)

	clr.w	chan_pgfx_active(a0)

	sf	chan_blockmarked(a0)
	sf	chan_cursorset(a0)

	rts



InitChannelselectData
	lea	chanselect_channels(a5),a0
	lea	chanselect_mappings(a5),a1
	moveq	#15,d1
.initloop
	bsr.s	default_channelvalues
	moveq	#-1,d0
	move.l	d0,chan_ltwh(a0)
	clr.w	(a1)+
	lea	chan_sizeof(a0),a0
	dbf	d1,.initloop

	move.w	#1,chanselect_mappings(a5)
	moveq	#-1,d0
	move.l	d0,active_channelwindow(a5)
	rts






	IFEQ	1

init_current_onoffs
	move.l	current_onoffs(a5),a0
	move.l	current_states(a5),a1
	move.l	maxtracks_m1(a5),d0
.initlp	st	(a0)+
	sf	(a1)+			; to make sure textgadgets will change
	dbf	d0,.initlp
	rts


init_currentcs_onoffs
	lea	cs_onoffs(a5),a0
	lea	cs_states(a5),a1
	move.l	active_csources_m1(a5),d0
.initlp	st	(a0)+
	sf	(a1)+
	dbf	d0,.initlp
	st	currentmp_onoff(a5)
	st	currentpb_onoff(a5)
	sf	currentmp_state(a5)
	sf	currentpb_state(a5)
	rts

	ENDC





InitControlsourcesData

;=== allocate one default controlsource: modwheel

	bsr	FreeControlsourcesData

	move.w	#1,pgfx_active(a5)

	moveq	#1,d0			; Modwheel
;	moveq	#0,d1			; panic value
;	bra.s	AddControlSource




AddControlSource	; d0.b = parameter number
			; returns: pos/neg

;=== Make sure the new csource is not yet in the list!

			rsreset
.sp_new_active		rs.l	1
.sp_new_code		rs.b	1
			rs.b	1
			rs.w	1
;.sp_new_worktracks	rs.l	1
;.sp_ctrackchanged	rs.l	1
.sp_recevents		rs.l	1
.sp_recevents_spare	rs.l	1
;.sp_csc			rs.w	1
;.sp_chanc		rs.w	1
;.sp_playcounters	rs.l	1
.sp_sizeof		rs.w	0


	movem.l	d2/d4-d5,-(sp)

	lea	-.sp_sizeof(sp),sp

	move.b	d0,.sp_new_code(sp)


	move.l	active_csources(a5),d0
	addq.l	#1,d0
	move.l	d0,.sp_new_active(sp)




;=== allocate new worktracks
;	move.l	.sp_new_active(sp),d0
;	bsr	AllocCSWorktracks
;	move.l	d0,.sp_new_worktracks(sp)
;	beq	.nomem1



;=== allocate new changed-flags
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_ctrackchanged(sp)
;	beq	.nomem9


;=== allocate new record-events
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_recevents(sp)
;	beq	.nomemA


;=== allocate new record-events for spare
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_recevents_spare(sp)
;	beq	.nomemB


;=== allocate playcounters
;	moveq	#prec3,d0
;	move.l	.sp_new_active(sp),d1
;	mulu	#pcc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_csc(sp)

;	move.l	maxtracks(a5),d1
;	mulu	#pc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_chanc(sp)

;	lsl.l	#4,d0				; 16 channels
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_playcounters(sp)
;	beq	.nomemC





;=== Now we want to copy the old values into the new tables.
;=== At this place, we insert the new value.

	move.b	.sp_new_code(sp),d2

	move.l	active_csources(a5),d5
	beq.s	.first_cs1
	move.l	d5,d4			; d5 = dest, d4 = source offset

.insertloop
	subq.l	#1,d4
	bcs.s	.first_cs1

	cmp.l	d4,d5
	beq.s	.notyet

	lea	codetab(a5),a0
	cmp.b	(a0,d4.l),d2
	bls.s	.notyet



.first_cs1
	lea	codetab(a5),a1
	move.b	d2,(a1,d5.l)

;	lea	cs_states(a5),a1
;	sf	(a1,d5.l)			; mark state empty

;	lea	cs_onoffs(a5),a1
;	st	(a1,d5.l)			; track is on

	cmp.b	#$80,d2
	beq.s	.mp1

	lea	cs_ifilters(a5),a0
	lea	cs_ofilters(a5),a1
	IFEQ	mc68020
	move.l	d5,d0
	add.l	d0,d0
	clr.w	(a0,d0.l)
	clr.w	(a1,d0.l)
	ELSE
	clr.w	(a0,d5.l*2)
	clr.w	(a1,d5.l*2)
	ENDC
.mp1

	addq.l	#1,d4
	bra.s	.goon

.notyet
	lea	codetab(a5),a1
	move.b	(a1,d4.l),(a1,d5.l)

;	lea	cs_onoffs(a5),a0
;	move.b	(a0,d4.l),(a0,d5.l)

;	lea	cs_states(a5),a0
;	move.b	(a0,d4.l),(a0,d5.l)

	cmp.b	#$80,d2
	beq.s	.mp2

	lea	cs_ifilters(a5),a0
	lea	cs_ofilters(a5),a1
	IFEQ	mc68020
	move.l	d4,d0
	add.l	d0,d0
	move.l	d5,d1
	add.l	d1,d1
	move.w	(a0,d0.l),(a0,d1.l)
	move.w	(a1,d0.l),(a1,d1.l)
	ELSE
	move.w	(a0,d4.l*2),(a0,d5.l*2)
	move.w	(a1,d4.l*2),(a1,d5.l*2)
	ENDC
.mp2


;	move.l	ctrackchanged(a5),a0
;	move.l	.sp_ctrackchanged(sp),a1
;	move.b	(a0,d4.l),(a1,d5.l)

.goon	subq.l	#1,d5
	bcc	.insertloop




;=== make new pointers public

	bsr	FreeControlSourcesData

.first_cs2
;	move.l	.sp_new_worktracks(sp),cworktracks(a5)
;	move.l	.sp_ctrackchanged(sp),ctrackchanged(a5)
;	move.l	.sp_recevents(sp),recevents_cs(a5)
;	move.l	.sp_recevents_spare(sp),recevents_cs_spare(a5)

;	move.w	.sp_csc(sp),csc(a5)
;	move.w	.sp_chanc(sp),chanc(a5)
;	move.l	.sp_playcounters(sp),playcounters(a5)

	move.l	.sp_new_active(sp),d0
	bsr.s	PutActiveCsources

	lea	.sp_sizeof(sp),sp
	movem.l	(sp)+,d2/d4-d5
	POSITIV


;.nomemD
;	lea	.sp_playcounters(sp),a0
;	bsr	MyFreeVector

.nomemC
;	lea	.sp_recevents_spare(sp),a0
;	bsr	MyFreeVector

;.nomemB
;	lea	.sp_recevents(sp),a0
;	bsr	MyFreeVector

;.nomemA
;	lea	.sp_ctrackchanged(sp),a0
;	bsr	MyFreeVector

;.nomem9
;	lea	.sp_new_worktracks(sp),a0
;	bsr	MyFreeVector

;.nomem1
	lea	.sp_sizeof(sp),sp
	movem.l	(sp)+,d2/d4-d5
	NEGATIV





PutActiveCsources	; d0.l=number of active csources
	move.l	d0,active_csources(a5)
	subq.l	#1,d0
	move.l	d0,active_csources_m1(a5)
	rts



FreeControlsourcesData

;	lea	playcounters(a5),a0
;	bsr	MyFreeVector

;	lea	recevents_cs_spare(a5),a0
;	bsr	MyFreeVector

;	lea	recevents_cs(a5),a0
;	bsr	MyFreeVector

;	lea	ctrackchanged(a5),a0
;	bsr	MyFreeVector

;	bsr	FreeCWorktracks

	moveq	#0,d0
	bra.s	PutActiveCsources





DelControlSource	; d0.b = list-number of the controlsource
			; returns: pos/neg

;=== Make sure the csource is in the list!

			rsreset
.sp_new_active		rs.l	1
.sp_code		rs.b	1
			rs.b	1
			rs.w	1
.sp_new_worktracks	rs.l	1
.sp_ctrackchanged	rs.l	1
.sp_recevents		rs.l	1
.sp_recevents_spare	rs.l	1
.sp_csc			rs.w	1
.sp_chanc		rs.w	1
.sp_playcounters	rs.l	1
.sp_sizeof		rs.w	0


	movem.l	d2/d4-d5,-(sp)

	lea	-.sp_sizeof(sp),sp

	move.b	d0,.sp_code(sp)
	move.l	active_csources_m1(a5),.sp_new_active(sp)



;=== allocate new worktracks
;	move.l	.sp_new_active(sp),d0
;	bsr	AllocCSWorktracks
;	move.l	d0,.sp_new_worktracks(sp)
;	beq	.nomem1



;=== allocate new changed-flags
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_ctrackchanged(sp)
;	beq	.nomem9


;=== allocate new record-events
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_recevents(sp)
;	beq	.nomemA


;=== allocate new record-events for spare
;	move.l	.sp_new_active(sp),d0
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_recevents_spare(sp)
;	beq	.nomemB


;=== allocate playcounters
;	moveq	#prec3,d0
;	move.l	.sp_new_active(sp),d1
;	mulu	#pcc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_csc(sp)

;	move.l	maxtracks(a5),d1
;	mulu	#pc_sizeof,d1
;	add.l	d1,d0
;	move.w	d0,.sp_chanc(sp)

;	lsl.l	#4,d0				; 16 channels
;	moveq	#1,d1
;	bsr	MyAllocVec
;	move.l	d0,.sp_playcounters(sp)
;	beq	.nomemC





;=== Now we want to copy the old values into the new tables.

	move.b	.sp_code(sp),d2

	moveq	#0,d4			; d4 = source offset
	moveq	#0,d5			; d5 = dest offset

.cutloop
	cmp.b	d4,d2
	bhi.s	.goon
	beq.s	.more


	lea	codetab(a5),a0
	move.b	(a0,d4.l),(a0,d5.l)

;	lea	cs_onoffs(a5),a0
;	move.b	(a0,d4.l),(a0,d5.l)

;	lea	cs_states(a5),a0
;	move.b	(a0,d4.l),(a0,d5.l)

	lea	cs_ifilters(a5),a0
	lea	cs_ofilters(a5),a1
	IFEQ	mc68020
	move.l	d4,d0
	add.l	d0,d0
	move.l	d5,d1
	add.l	d1,d1
	move.w	(a0,d0.l),(a0,d1.l)
	move.w	(a1,d0.l),(a1,d1.l)
	ELSE
	move.w	(a0,d4.l*2),(a0,d5.l*2)
	move.w	(a1,d4.l*2),(a1,d5.l*2)
	ENDC

;	move.l	ctrackchanged(a5),a0
;	move.l	.sp_ctrackchanged(sp),a1
;	move.b	(a0,d4.l),(a1,d5.l)


.goon	addq.l	#1,d5
.more	addq.l	#1,d4
	cmp.l	active_csources(a5),d4
	bcs.s	.cutloop




;=== make new pointers public

	bsr	FreeControlSourcesData

.first_cs2
;	move.l	.sp_new_worktracks(sp),cworktracks(a5)
;	move.l	.sp_ctrackchanged(sp),ctrackchanged(a5)
;	move.l	.sp_recevents(sp),recevents_cs(a5)
;	move.l	.sp_recevents_spare(sp),recevents_cs_spare(a5)

;	move.w	.sp_csc(sp),csc(a5)
;	move.w	.sp_chanc(sp),chanc(a5)
;	move.l	.sp_playcounters(sp),playcounters(a5)

	move.l	.sp_new_active(sp),d0
	bsr	PutActiveCsources

	lea	.sp_sizeof(sp),sp
	movem.l	(sp)+,d2/d4-d5
	POSITIV


;.nomemD
;	lea	.sp_playcounters(sp),a0
;	bsr	MyFreeVector

.nomemC
;	lea	.sp_recevents_spare(sp),a0
;	bsr	MyFreeVector

;.nomemB
;	lea	.sp_recevents(sp),a0
;	bsr	MyFreeVector

;.nomemA
;	lea	.sp_ctrackchanged(sp),a0
;	bsr	MyFreeVector

;.nomem9
;	lea	.sp_new_worktracks(sp),a0
;	bsr	MyFreeVector

;.nomem1
	lea	.sp_sizeof(sp),sp
	movem.l	(sp)+,d2/d4-d5
	NEGATIV










;=== is called from InitNewData and retrieve_song

;InitVars






;=== Channelnames auf leer setzen

reset_channelnames
	lea	channelnames(a5),a3
	moveq	#15,d0
.clrloop
	IFEQ	channelname_len-24
	REPT	6
	clr.l	(a3)+
	ENDR
	ELSE
	REPT	channelname_len
	clr.b	(a3)+
	ENDR
	ENDC
	dbf	d0,.clrloop
	rts




init_tables

;=== correct absolute addresses in windowstructures
	lea	all_windows_start,a1
	moveq	#windows_number-1,d3

.correctloop
	lea	.wstruct_offsets(pc),a2

.windowloop
	move.w	(a2)+,d0
	bmi.s	.nextwin

	lea	(a1,d0.w),a0
	move.l	(a0),d0
	beq.s	.nope
	add.l	a0,d0
	move.l	d0,(a0)
.nope

	bra.s	.windowloop
.nextwin

	lea	wd_structsize(a1),a1
	dbf	d3,.correctloop
.done




;=== Datatable in varbase eintragen!
	lea	datasource,a0
	lea	datatable(a5),a1
	move.l	#datalen,d0
	move.l	(a5),a6
	jsr	CopyMem(a6)



;=== Jumptable in varbase eintragen!
	move.l	jumpsourceD(a5),a0
	lea	jumptable(a5),a1
	move.w	#$4ef9,d2		; Opcode fr JMP $xxxxxxx.l
	move.w	#jumplen/4-1,d3
.jloop	move.w	d2,(a1)+
	move.l	a0,a2
	adda.l	(a0)+,a2
	move.l	a2,(a1)+
	dbf	d3,.jloop

	move.l	(a5),a6
	jmp	CacheClearU(a6)



.wstruct_offsets
	dc.w	wd_GTags
	dc.w	wd_NGads
	dc.w	wd_GTypes
	dc.w	wd_WindowTags
	dc.w	wd_NewMenu0
	dc.w	wd_Bevels
	dc.w	wd_IText
	dc.w	wd_IDCMP
	dc.w	wd_AGlink
	dc.w	-1


;=== csworktracks allocaten

	IFEQ	1

AllocCSWorktracks	; d0=number of csources
			; returns: d0=^worktracks or NULL

	move.l	events(a5),d1
	mulu	d1,d0
	moveq	#1,d1
	bsr	MyAllocVec
	tst.l	d0
	rts

	ENDC



	IFEQ	1

ReAllocWorkTracks	; new values in:
			; active_csources, maxtracks, events

			rsreset
.sp_worktracks		rs.l	1
.sp_cworktracks		rs.l	1
.sp_mpworktrack		rs.l	1
.sp_pworktrack		rs.l	1
.sp_pbworktrack		rs.l	1
.sp_bpmworktrack	rs.l	1
.sp_sizeof		rs.w	0



	lea	-.sp_sizeof(sp),sp


	move.l	active_csources(a5),d0
	bsr.s	AllocCSWorktracks
	beq	.neg1
	move.l	d0,.sp_cworktracks(sp)


;=== pitchworktrack allocaten
	move.l	events(a5),d0
	add.l	d0,d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_pbworktrack(sp)
	beq	.neg2


;=== mpress worktrack allocaten
	move.l	events(a5),d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_mpworktrack(sp)
	beq.s	.neg3


;=== presetworktrack allocaten
	move.l	events(a5),d0
	add.l	d0,d0
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,.sp_pworktrack(sp)
	beq.s	.neg4


;=== bpmworktrack allocaten
	move.l	events(a5),d0
	add.l	d0,d0
	move.l	#$10001,d1
	bsr	MyAllocVec
	move.l	d0,.sp_bpmworktrack(sp)
	beq.s	.neg5


;=== allocate note-worktracks if the aren't yet allocated
	move.l	maxtracks(a5),d1
	bsr.s	AllocNWorktracks
	beq.s	.neg6
	move.l	d0,.sp_worktracks(sp)


;=== all allocations were successful, now release the old ones

	bsr	FreeAllWorktracks

	move.l	.sp_worktracks(sp),worktracks(a5)
	move.l	.sp_cworktracks(sp),cworktracks(a5)
	move.l	.sp_pworktrack(sp),pworktrack(a5)
	move.l	.sp_pbworktrack(sp),pbworktrack(a5)
	move.l	.sp_mpworktrack(sp),mpworktrack(a5)
	move.l	.sp_bpmworktrack(sp),bpmworktrack(a5)

	lea	.sp_sizeof(sp),sp
	POSITIV


.neg6	lea	.sp_bpmworktrack(sp),a0
	bsr	MyFreeVector

.neg5	lea	.sp_pworktrack(sp),a0
	bsr	MyFreeVector

.neg4	lea	.sp_mpworktrack(sp),a0
	bsr	MyFreeVector

.neg3	lea	.sp_pbworktrack(sp),a0
	bsr	MyFreeVector

.neg2	lea	.sp_cworktracks(sp),a0
	bsr	MyFreeVector

.neg1	lea	.sp_sizeof(sp),sp
	NEGATIV





AllocNWorktracks	; d1=maxtracks
	move.l	events(a5),d0
	lsl.w	#2,d1			; = mulu #wd_sizeof,d1
	mulu	d1,d0
	moveq	#1,d1
	bsr	MyAllocVec
	tst.l	d0
	rts




InitWorktracks
	jsr	defaulttracksJ(a5)
	jsr	defaultctracksJ(a5)
	jsr	defaultpbtrackJ(a5)
	jsr	defaultmptrackJ(a5)
	jsr	defaultptrackJ(a5)
	jmp	defaultbpmtrackJ(a5)


	ENDC





;==============================================================
;
;  MIDI-process launchen
;
;==============================================================

LaunchMidiProcess

;=== allocate messageport for incoming midi-msgs
	jsr	CreateMsgPort(a6)
	move.l	d0,midiin_port_main(a5)
	beq.s	.neg

	jsr	CreateMsgPort(a6)
	move.l	d0,midi_replyport_main(a5)
	beq.s	.neg


;=== clear some signal
	moveq	#0,d0
	move.l	#$8000,d1
	jsr	SetSignal(a6)


;=== kick up process
	lea	.proctags(pc),a0
	move.l	a0,d1
	move.l	dosbas(a5),a6
	jsr	CreateNewProc(a6)
	tst.l	d0
	beq.s	.neg


;=== wait for playerprocess to initialize itself
	move.l	#$8000,d0
	move.l	(a5),a6
	jsr	Wait(a6)
	tst.l	midiprocess(a5)
	beq.s	.neg


	POSITIV
.neg	NEGATIV


.proctags
	dc.l	$800003e8+3,midiprocess_start	; Entry
	dc.l	$800003e8+11,4096		; Stacksize
	dc.l	$800003e8+12,midiprocname	; Name
	dc.l	$800003e8+13,5			; Priority
	dc.l	0





;==============================================================
;
;  Midi-process entfernen
;
;==============================================================

KillMidiProcess
	move.l	(a5),a6
	tst.l	midiprocess(a5)
	beq.s	.nomidi

;=== clear ctrl-f, this is the signal scoper will answer
	moveq	#0,d0
	move.l	#$8000,d1
	jsr	SetSignal(a6)

	lea	midiprocname(pc),a1
	jsr	FindTask(a6)
	tst.l	d0
	beq.s	.nomidi

;=== dem Playerprocess Bescheid geben, da er sich beenden soll
	move.l	d0,a1
	moveq	#0,d0
	move.b	shutdown_midi_sig(a5),d1
	bset	d1,d0
	jsr	Signal(a6)

	move.l	#$8000,d0
	jsr	Wait(a6)

	clr.l	midiprocess(a5)
.nomidi

;=== Signale freigeben
	move.l	midiin_port_main(a5),d0
	beq.s	.noport
	move.l	d0,a0
	jsr	DeleteMsgPort(a6)
.noport

	move.l	midi_replyport_main(a5),d0
	beq.s	.noport2
	move.l	d0,a0
	jsr	DeleteMsgPort(a6)
.noport2

	rts




;==============================================================
;
;  Player-process
;
;==============================================================

LaunchPlayerProcess

;	moveq	#-1,d0
;	move.l	(a5),a6
;	jsr	AllocSignal(a6)
;	move.b	d0,answersignal(a5)
;	bmi.s	.neg

;=== clear some signal
	moveq	#0,d0
	move.l	#$8000,d1
	jsr	SetSignal(a6)

;=== kick up process
	lea	.proctags(pc),a0
	move.l	a0,d1
	move.l	dosbas(a5),a6
	jsr	CreateNewProc(a6)
	tst.l	d0
	beq.s	.neg

;=== wait for process to initialize itself
	move.l	#$8000,d0
	move.l	(a5),a6
	jsr	Wait(a6)
	tst.l	playerprocess(a5)
	beq.s	.neg


	POSITIV
.neg	NEGATIV


.proctags
	dc.l	$800003e8+3,playerprocess_start	; Entry
	dc.l	$800003e8+11,4096		; Stacksize
	dc.l	$800003e8+12,playerprocname	; Name
	dc.l	$800003e8+13,40			; Priority (should be >30
						; because this is the prio
						; of midilib's processes)
	dc.l	0




KillPlayerProcess
	move.l	(a5),a6
	tst.l	playerprocess(a5)
	beq.s	.nomidi

;=== clear ctrl-f, this is the signal for answer
	moveq	#0,d0
	move.l	#$8000,d1
	jsr	SetSignal(a6)

	lea	playerprocname(pc),a1
	jsr	FindTask(a6)
	tst.l	d0
	beq.s	.nomidi

;=== dem Playerprocess Bescheid geben, da er sich beenden soll
	move.l	d0,a1
	moveq	#0,d0
	move.b	shutdown_player_sig(a5),d1
	bset	d1,d0
	jsr	Signal(a6)
	move.l	#$8000,d0
	jsr	Wait(a6)

	clr.l	playerprocess(a5)
.nomidi

;	move.b	answersignal(a5),d0
;	bmi.s	.nosig
;	jsr	FreeSignal(a6)
;.nosig

	rts


;==============================================================
;
;  Scoper-process launchen
;
;==============================================================

LaunchScoper

;=== allocate sigbit to get signalled from scoper
	moveq	#-1,d0
	move.l	(a5),a6
	jsr	AllocSignal(a6)
	move.b	d0,scoper2main_sig(a5)
	bmi.s	.neg


;=== erase ctrl-f
	moveq	#0,d0
	move.l	#$8000,d1
	move.l	(a5),a6
	jsr	SetSignal(a6)

;=== create scoper process
	lea	.scopertags(pc),a0
	move.l	a0,d1
	move.l	dosbas(a5),a6
	jsr	CreateNewProc(a6)
	tst.l	d0
	beq.s	.neg

;=== wait for scoper to initialize itself
	move.l	#$8000,d0
	move.l	(a5),a6
	jsr	Wait(a6)		; warten, ob scoper erfolgreich startet
	tst.l	scoperprocess(a5)
	beq.s	.neg			; scoper nicht hochgefahren


	POSITIV
.neg	NEGATIV

.scopertags
	dc.l	$800003e8+3,scoperstart	; Entry
	dc.l	$800003e8+11,2048	; Stacksize
	dc.l	$800003e8+12,scopername	; Name
	dc.l	$800003e8+13,1		; Priority
	dc.l	0


midiprocname	dc.b	'MT Midi',0
playerprocname	dc.b	'MT Player',0
scopername	dc.b	'MT Scoper',0
		even



;==============================================================
;
;  Scoper-process entfernen
;
;==============================================================

KillScoper
	move.l	(a5),a6
	tst.l	scoperprocess(a5)
	beq.s	.noscoper

;=== clear ctrl-f, this is the signal scoper will answer
	moveq	#0,d0
	move.l	#$8000,d1
	jsr	SetSignal(a6)

;=== findtask scoper, to be sure it is still there
	lea	scopername(pc),a1
	jsr	FindTask(a6)
	tst.l	d0
	beq.s	.noscoper

;=== tell scoper to shutdown, wait for scoper to finish itself
	move.l	d0,a1
	move.l	#$8000,d0
	jsr	Signal(a6)
	move.l	#$8000,d0
	jsr	Wait(a6)

.noscoper
	clr.l	scoperprocess(a5)


;=== free sigbit for scoper
	move.b	scoper2main_sig(a5),d0
	jsr	FreeSignal(a6)

	rts








;==============================================================
;
;  allocate/free Record-Buffer
;
;==============================================================

AllocRecBuf
	move.l	recbufsizebytes(a5),d0
	beq.s	.neg
	moveq	#1,d1
	bsr	MyAllocVec
	move.l	d0,recbuf(a5)
	beq.s	.neg
	POSITIV
.neg	NEGATIV


FreeRecBuf
	lea	recbuf(a5),a0
	bra	MyFreeVector






;==============================================================
;
;  Globalen IDCMP-Port allocaten
;
;==============================================================

SetupIDCMP
	move.l	(a5),a6
	jsr	CreateMsgPort(a6)
	move.l	d0,IDCMPport(a5)
	beq.s	.neg
	POSITIV
.neg	NEGATIV

FreeIDCMP
	move.l	IDCMPport(a5),d0
	beq.s	.rts
	move.l	d0,a0
	move.l	(a5),a6
	jmp	DeleteMsgPort(a6)
.rts	rts






;==============================================================
;
;  Diese Routine gibt alles frei, was es gibt.
;
;==============================================================

FreeSomething

;	tst.l	intbas(a5)
;	beq	.crushed
;	tst.l	dosbas(a5)
;	beq	.crushed
;	tst.l	gadbas(a5)
;	beq	.crushed
;	tst.l	gfxbas(a5)
;	beq	.crushed


	jsr	stop_routineJ(a5)

	jsr	CloseVisualsJ(a5)
	bsr	CleanupIconifyState
	bsr.s	FreeIDCMP

	lea	k2kprograms(a5),a0
	bsr	MyFreeVector
	lea	quadraprograms(a5),a0
	bsr	MyFreeVector

;	jsr	FreeZoomHistJ(a5)
;	jsr	FreeSprocBufferJ(a5)

	bsr	FreeSongs		; all patterndata is freed here

	bsr	FreeUNDOdata
	bsr	FreeTrackbuffer
	bsr	FreeChannelbuffer
	bsr	FreePatternbuffer
	bsr	FreePBbuffer
	bsr	FreeCSbuffer
	bsr	FreePRbuffer
	bsr	FreeBPMbuffer

	bsr	FreeBlockPB
	bsr	FreeBlockCS
	bsr	FreeBlockBPM
	bsr	FreeBlockPre
	bsr	FreeBlockChan
	bsr	FreeBlockTrack

	bsr	xpk_free
	bsr	RemoveArexxPort

	bsr	KillScoper
	bsr	KillMidiProcess
	bsr	KillPlayerProcess

	bsr	free_controlsources
	bsr	save_quickloader

	bsr	FreeMaxtracksData
	bsr	FreeControlsourcesData	; call this AFTER FreeSongs()
	bsr	free_args		; + CD
	bsr	FreeReqToolsData
	bsr	unload_catalog

	jsr	close_amigaguideJ(a5)



	move.l	fib(a5),d2
	beq.s	.nofib
	moveq	#2,d1
	move.l	dosbas(a5),a6
	jsr	FreeDosObject(a6)
.nofib



;.crushed

	bsr	CloseTimer_main


;=== Alle Libraries freigeben
	move.l	(a5),a6
	lea	libraries(pc),a2
	moveq	#libsnum-1,d7
.libloop
	move.w	4(a2),d2
	move.l	(a5,d2.w),d1
	beq.s	.isfree
	move.l	d1,a1
	jsr	CloseLibrary(a6)

	IFNE	keyfile_active
	cmp.w	#keybas,d2
	bne.s	.isfree
	ENDC
.remove	jsr	Forbid(a6)
	move.l	(a5,d2.w),a1
	jsr	RemLibrary(a6)		; flush keyfile
	jsr	Permit(a6)

.isfree	addq.w	#8,a2
	dbf	d7,.libloop



	move.b	reply_sig(a5),d0
	bmi.s	.nosig1
	jsr	FreeSignal(a6)
.nosig1

	move.b	replayoutput_sig(a5),d0
	bmi.s	.nosig2
	jsr	FreeSignal(a6)
.nosig2

	move.l	todo_port(a5),d0
	beq.s	.notodo
	move.l	d0,a0
	jsr	DeleteMsgPort(a6)
.notodo



;=== Restore original taskname
;	move.l	oldtaskname(a5),d0
;	beq.s	.notchanged
;	move.l	mytask(a5),a0
;	move.l	d0,$a(a0)
	lea	maintask_semaphore(a5),a0
	tst.l	$a(a0)
	beq.s	.notchanged

	jsr	ReleaseSemaphore(a6)

	lea	maintask_semaphore(a5),a1
	jsr	RemSemaphore(a6)
.notchanged



;=== cleanup wb-message
	IFNE	executable
	move.l	wbenchmsg(a5),d0
	beq.s	.fromcli

	jsr	Forbid(a6)	; so wb cant unloadseg() us
	move.l	wbenchmsg(a5),a1
	jsr	ReplyMsg(a6)
.fromcli
	ENDC


	rts





FreeReqToolsData

;=== Reqtools-Strukturen freigeben
	move.l	rtbas(a5),d0
	beq.s	.rts
	move.l	d0,a6

	lea	.rtstructs(pc),a2
.freeloop
	move.w	(a2)+,d2
	beq.s	.done
	move.l	(a5,d2.w),d0
	beq.s	.req1
	clr.l	(a5,d2.w)
	move.l	d0,a1
	jsr	rtFreeRequest(a6)
.req1	bra.s	.freeloop
.done
.rts	rts



.rtstructs

	dc.w	rt_loadsong_fr
	dc.w	rt_savemt_fr
	dc.w	rt_savemid_fr
;	dc.w	rt_spload_fr
;	dc.w	rt_spsave_fr
	dc.w	rt_ezreq
;	dc.w	rt_sdsload_fr
;	dc.w	rt_sdssave_fr
	dc.w	rt_smreq
	dc.w	rt_fontreq
	dc.w	rt_prefs_fr
	dc.w	rt_pattern_fr
	dc.w	rt_channel_fr
	dc.w	0




FreeMemory	; a0=^address, d0=size
	move.l	(a0),d1
	beq.s	.rts
	move.l	d1,a1
	clr.l	(a0)
	move.l	(a5),a6
	jsr	FreeMem(a6)
.rts	rts


FreePattern	; d0.w=pattern
	move.l	patterntab(a5),a0
	lsl.w	#2,d0
	adda.w	d0,a0

FreePatternAddr	; a0=^Patternaddress
	move.l	a0,-(sp)
	bsr.s	FreePattChannels
	move.l	(sp)+,a0

FreePatternHead	; a0=^Patternaddress
	moveq	#pt_sizeof,d0
	bra.s	FreeMemory


FreePattChannels	; a0=^Patternaddress
;=== gibt alle Channels und BPMTrack eines Patterns frei
	move.l	(a0),d0
	beq.s	.rts
	move.l	a3,-(sp)
	move.l	d0,a3
	move.l	a3,a0
	bsr.s	FreeBPMTrack

	lea	pt_channels(a3),a3
	moveq	#15,d4		;16 midi channels
.loop2	move.l	a3,a0		;^channeladr
	bsr.s	FreeChannel
	addq.w	#4,a3
	dbf	d4,.loop2
.out	move.l	(sp)+,a3
.rts	rts



;=== bpmtrack freigeben
FreeBPMTrack	; a0=^pattern
	lea	pt_bpmtrack(a0),a0
	bra	MyFreeVector



;=== gibt den ctrack, die anderen tracks und sich selbst frei
FreeChannel	; a0=^channeladdress
	move.l	(a0),d0
	bne.s	.free
	rts
.free	clr.l	(a0)
	move.l	d0,-(sp)
	bsr.s	FreeInChannel
	move.l	(sp)+,a1
	moveq	#ch_sizeof,d0
	move.l	(a5),a6
	jmp	FreeMem(a6)



;=== gibt nur den ctrack und die tracks frei, nicht den channel selbst!
FreeInChannel	; d0=^channel
	move.l	a2,-(sp)
	move.l	d0,a2

	move.l	a2,a0
	bsr.s	FreePTrack
	move.l	a2,a0
	bsr.s	FreePBTrack
;	move.l	a2,a0
;	bsr.s	FreeMPTrack

	lea	ch_cstracks(a2),a0
	bsr.s	FreeListVecs
	lea	ch_tracks(a2),a0
	bsr.s	FreeListVecs

	move.l	(sp)+,a2
	rts



;=== gibt den pbtrack eines Channels frei
FreePBTrack	; a0=^Channel
	lea	ch_pbtrack(a0),a0
	bra	MyFreeVector



;=== gibt den presettrack eines Channels frei
FreePTrack	; a0=^Channel
	lea	ch_ptrack(a0),a0
	bra	MyFreeVector



;=== gibt den mptrack eines Channels frei
;FreeMPTrack	; a0=^Channel
;	lea	ch_mptrack(a0),a0
;	bra	MyFreeVector



FreeListVecs	; a0=^List-Root
	move.l	(a0),d0
	beq.s	.rts
	move.l	a2,-(sp)
	clr.l	(a0)
.loop3	move.l	d0,a1
	move.l	(a1),a2			; successor
	bsr	MyFreeVec
	move.l	a2,d0
	bne.s	.loop3
	move.l	(sp)+,a2
.rts	rts





	IFEQ	1

;=== Alle worktracks freigeben
FreeAllWorkTracks
	bsr.s	FreeCWorkTracks
	bsr.s	FreeBPMWorkTrack
	bsr.s	FreePWorkTrack
	bsr.s	FreePBWorkTrack
	bsr.s	FreeMPWorkTrack
;=== es geht weiter!
;	bra.s	FreeWorkTracks




FreeWorkTracks	; worktracks freigeben
	lea	worktracks(a5),a0
	bra.s	MyFreeVector


FreeBPMWorktrack ; bpmworktrack freigeben
	lea	bpmworktrack(a5),a0
	bra.s	MyFreeVector


FreeCWorktracks	; controlworktrack freigeben
	lea	cworktracks(a5),a0
	bra.s	MyFreeVector


FreePBWorktrack	; pitchworktrack freigeben
	lea	pbworktrack(a5),a0
	bra.s	MyFreeVector


FreeMPWorktrack	; mpress worktrack freigeben
	lea	mpworktrack(a5),a0
	bra.s	MyFreeVector


FreePWorktrack	; presetworktrack freigeben
	lea	pworktrack(a5),a0
;	bra.s	MyFreeVector

	ENDC



MyFreeVector	; a0 = ^Memoryaddress
	move.l	(a0),d0
	beq.s	.rts
	clr.l	(a0)
	move.l	d0,a1
	bra.s	MyFreeVec
.rts	rts

MyFreeVec	; a1 = ^address
	move.l	-(a1),d0
	move.l	(a5),a6
	jmp	FreeMem(a6)



MyAllocVec	; d0 = size, d1 = alloc-flags
	addq.l	#4,d0
	move.l	d0,-(sp)
	move.l	(a5),a6
	jsr	AllocMem(a6)
	tst.l	d0
	beq.s	.nomem
	move.l	d0,a0
	move.l	(sp)+,(a0)+
	move.l	a0,d0
	rts
.nomem	addq.w	#4,sp
	rts







;=== wird von FreeSomething, project_clear und load_mt aufgerufen!
FreePatternData
;=== gibt alle Patterns frei, und Positions + Patterntab
	tst.l	patterntab(a5)
	beq.s	.rts
	move.l	patterntablen(a5),-(sp)
.loop	subq.l	#1,(sp)
	bcs.s	.out
	move.l	(sp),d0
	bsr	FreePattern	; patterns freigeben
	bra.s	.loop
.out	addq.w	#4,sp

	jsr	FreePosNPattsJ(a5)
.rts	rts




;==============================================================
;
;  UNDO-Patterntab allocaten
;
;==============================================================

AllocUNDOtab
	move.l	patterntablen(a5),d0
	lsl.l	#2,d0
	move.l	#$10001,d1
	bsr	MyAllocVec
	move.l	d0,undo_patterntab(a5)
	beq.s	.neg
	move.l	patterntablen(a5),undo_tablength(a5)
	POSITIV
.neg	NEGATIV



;==============================================================
;
;  UNDO-Patterntab freigeben, incl. Patterns
;
;==============================================================

FreeUNDOdata
	tst.l	undo_patterntab(a5)
	beq.s	.next
	move.l	undo_tablength(a5),-(sp)
.loop	subq.l	#1,(sp)
	bcs.s	.out

	move.l	(sp),d0
	move.l	undo_patterntab(a5),a0
	lsl.w	#2,d0
	adda.w	d0,a0
	bsr	FreePatternAddr
	bra.s	.loop

.out	addq.w	#4,sp
	lea	undo_patterntab(a5),a0
	bsr	MyFreeVector

.next	lea	undo_patternA(a5),a0	; free undo pattern
	bra	FreePatternAddr





FreeTrackbuffer
	lea	trackbuf_addr(a5),a0
	bra	MyFreeVector

FreeChannelbuffer
	lea	chanbuf_addr(a5),a0
	bra	FreeChannel

FreePatternbuffer
	lea	pattbuf_addr(a5),a0
	bra	FreePatternAddr

FreePBbuffer
	lea	PBbuf_addr(a5),a0
	bra	MyFreeVector

;FreeMPbuffer
;	lea	MPbuf_addr(a5),a0
;	bra	MyFreeVector

FreeCSbuffer
	lea	CSbuf_addr(a5),a0
	bra	MyFreeVector

FreePRbuffer
	lea	PRbuf_addr(a5),a0
	bra	MyFreeVector

FreeBPMbuffer
	lea	BPMbuf_addr(a5),a0
	bra	MyFreeVector





;==============================================================
;
;  Einige globale Strings localizen
;
;==============================================================

Localization
	move.l	windowtableD(a5),a2
	bra.s	.jin

.localeloop
	move.l	wd_NewMenu0(a5,d0.w),d0
	beq.s	.nomenu
	move.l	d0,a3
	tst.b	-(a3)			; Ist das Men bereits
	bne.s	.already		; localized?
	st	(a3)+			; Als "localized" markieren

.menuloop

	move.l	2(a3),d1		; MSW: String-offset
	moveq	#-1,d0
	cmp.l	d0,d1
	beq.s	.barlabel		; LSW: locale-number

	move.w	d1,d0			; d0 = locale-number
	bmi.s	.nolocale
	bsr	getcatstring
	bra.s	.loccont
.nolocale
	swap	d1			; d1 = String-offset if not localized
	lea	2(a3,d1.w),a1
.loccont
	move.l	a1,2(a3)		; String schreiben

	move.l	6(a3),d0		; Commkey-offset
	beq.s	.nocommkey
	lea	6(a3,d0.l),a1		; Adresse wird nur berechnet,
	move.l	a1,6(a3)		; nicht localized
.nocommkey

.barlabel
	lea	20(a3),a3
	tst.b	(a3)
	bne.s	.menuloop

.already
.nomenu
	lea	windowtable_entry_sizeof(a2),a2
.jin	move.w	(a2),d0
	bne.s	.localeloop

.out





;=== localize Cycle-/MX-Gadgets

	lea	.gadgetlist(pc),a2
	bra.s	.c2jin

.cycleloop
	lea	-4(a2,d0.l),a3		; ^Cycles-Table
	bra.s	.c1jin

.innerloop
	move.l	d0,d1
	swap	d1
	tst.w	d1
	bmi.s	.noloc
	bsr	getcatstring
	bra.s	.locc
.noloc	lea	2(a3,d0.w),a1
.locc	move.l	a1,(a3)+

.c1jin	move.l	(a3),d0
	bne.s	.innerloop

.c2jin	move.l	(a2)+,d0
	bne.s	.cycleloop




;=== localize itext-structures
	lea	.itextlist(pc),a2
	bra.s	.itjin

.itextloop

	lea	-4(a2,d0.l),a3
.textloop
	lea	$c(a3),a3
	move.l	(a3),d0
	tst.w	d0
	bmi.s	.noloc2
	jsr	getcatstringJ(a5)
	bra.s	.locc2
.noloc2	move.l	a3,a1
	swap	d0
	adda.w	d0,a1
.locc2	move.l	a1,(a3)+

	move.l	(a3),d1
	beq.s	.textout
	lea	(a3,d1.l),a0
	move.l	a0,(a3)
	move.l	a0,a3
	bra.s	.textloop
.textout

.itjin	move.l	(a2)+,d0
	bne.s	.itextloop


	rts




.gadgetlist
	dr.l	chanstyleLabels
;	dr.l	smploopLabels
	dr.l	transposeLabels
	dr.l	typeLabels
	dr.l	audioLabels
;	dr.l	smpbitsLabels
;	dr.l	smpsaverLabels
	dr.l	hideLabels
	dr.l	midiuseLabels
	dr.l	drawmodeLabels
	dr.l	panicmethodLabels
	dr.l	midimodeLabels
	dr.l	clockLabels
	dr.l	editmodeLabels
	dr.l	chordLabels
	dr.l	tabmodeLabels
	dr.l	recmodeLabels
	dr.l	inoutLabels
	dr.l	pressLabels
	dr.l	pchgTypeOffsets
	dr.l	velorppLabels
	dr.l	*



.itextlist
	dr.l	MTmetroText0
	dr.l	MTremapIText0
	dr.l	*





;==============================================================
;
;  pre-V39: COMMANDSTRING-Flag in NewMenu-Strukturen lschen
;
;==============================================================

v37_workaround
	tst.b	kick30(a5)
	bne.s	.noneed


;=== fix menu structures

	move.l	windowtableD(a5),a0
	bra.s	.jin

.v37loop

	move.l	wd_NewMenu0(a5,d0.w),d0
	beq.s	.already
	move.l	d0,a1
	tst.b	-2(a1)
	bne.s	.already
	st	-2(a1)

.menuloop
	bclr	#2,11(a1)	; NM_COMMANDSTRING-Bit lschen
	beq.s	.skipm
	clr.l	6(a1)

.skipm	lea	20(a1),a1
	tst.b	(a1)
	bne.s	.menuloop

.already
	lea	windowtable_entry_sizeof(a0),a0
.jin	move.w	(a0),d0
	bne.s	.v37loop
.out



;=== fix remapper numeric gadget-tags (ignore some v39-tags, see remapper)

	move.l	MTremapStruct+wd_GTags(a5),a0
	moveq	#changadget_tags_sizeof,d2
	moveq	#1,d1			; TAG_IGNORE
	moveq	#31,d0
.numericloop
	move.l	d1,$10(a0)
	move.l	d1,$18(a0)
	adda.l	d2,a0
	dbf	d0,.numericloop







.noneed

	rts




;==============================================================
;
;  XPK-Daten initialisieren (numpackers, xpklabels)
;
;==============================================================

xpk_init
	tst.l	xpkbas(a5)
	beq	.noxpk

	move.l	#4+100*6,d0
	moveq	#1,d1
	bsr	MyAllocVec		; Packerlist allocaten
	move.l	d0,packerlist(a5)
	beq	.noxpk

	lea	.xpkquerytags(pc),a0
	move.l	d0,4(a0)
	move.l	xpkbas(a5),a6
	jsr	XpkQuery(a6)
	tst.l	d0
	bne.s	.noxpk

	move.l	packerlist(a5),a0
	move.l	(a0),d0			; NumPackers
	beq.s	.noxpk			; falls keine Packer vorhanden
	mulu	#$e,d0
	move.l	d0,d2
	move.l	#$10001,d1
	bsr	MyAllocVec		; Labels allocaten
	move.l	d0,xpklists(a5)
	beq.s	.noxpk

	move.l	d0,a1
	lea	-$e(a1,d2.l),a2
	move.l	packerlist(a5),a3
	move.l	(a3)+,d0		; NumPackers
	subq.l	#1,d0
	beq.s	.skip1
	moveq	#$e,d1
.packerloop
	move.l	a3,$a(a1)
	adda.l	d1,a1
	move.l	a1,-$e(a1)
	suba.l	d1,a2
	move.l	a2,$e+4(a2)

	addq.w	#6,a3
	subq.l	#1,d0
	bne.s	.packerloop

.skip1
	move.l	a3,$a(a1)
	lea	xpkinitlist(a5),a0
	move.l	a0,4(a2)
	move.l	a2,(a0)
	addq.w	#4,a0
	move.l	a0,(a1)
	move.l	a1,4(a0)


	jsr	find_compressorJ(a5)

.out
	IFNE	keyfile_active
	lea	keybas-4(a5),a0
	move.l	4(a0),d0
	beq.s	.nokey
	move.l	d0,a6
	lea	len_buttonD(a5),a0
	move.l	MainGadgetUpTabD(a5),a1
	moveq	#GD_lengad,d0
	jsr	keyFixGadget(a6)
.nokey
	ENDC

	rts



.noxpk	sf	xpkonoff(a5)
	bra.s	.out



.xpkquerytags
	dc.l	$80005850+$32,0		; ^packerlist
	dc.l	0



;==============================================================
;
;  XPK-Daten wieder freigeben
;
;==============================================================

xpk_free
	lea	xpklists(a5),a0
	bsr	MyFreeVector
	lea	packerlist(a5),a0
	bra	MyFreeVector



;==============================================================
;
;  Commandline-arguments analysieren
;
;==============================================================

cli_args_and_tooltypes
	IFNE	executable

	move.l	wbenchmsg(a5),d0
	bne.s	.fromwb

;=== get the CurrentDir

;	move.l	startcdnameD(a5),d1
;	moveq	#108,d2
;	move.l	dosbas(a5),a6
;	jsr	GetCurrentDirName(a6)
;	tst.l	d0
;	bne.s	.cdok
;	move.l	startcdnameD(a5),a0
;	clr.b	(a0)
;.cdok

	move.l	mytask(a5),a0
	move.l	$5c+$3c(a0),d1
;	move.l	d1,startcdlock(a5)

	move.l	startcdnameD(a5),d2
	moveq	#108-1,d3
	move.l	dosbas(a5),a6
	jsr	NameFromLock(a6)

;	move.l	dosbas(a5),a6
;	jsr	DupLock(a6)
;	move.l	d0,d1
;	beq.s	.dos_error
;	move.l	d1,currentlock(a5)
;	jsr	CurrentDir(a6)


	lea	.template(pc),a0
	move.l	a0,d1
	lea	argarray(a5),a0
	move.l	a0,d2
	moveq	#0,d3
	jsr	ReadArgs(a6)
	move.l	d0,rdargs(a5)
	beq.s	.dos_error
	bra	.further

.dos_error
	bsr	dos_error
	bra	.neg


.fromwb
	move.l	d0,a0
	move.l	$24(a0),d0	; sm_ArgList
	beq.s	.wberr

	move.l	d0,a0
	move.l	$4(a0),d0	; wa_Name
	beq.s	.wberr
	move.l	d0,a2

;=== set current directory, to load preferences from (not here, but later)
;	move.l	(a0),d1
;	move.l	d1,startcdlock(a5)
;	move.l	dosbas(a5),a6
;	jsr	DupLock(a6)
;	move.l	d0,d1
;	beq.s	.dos_error
;	move.l	d1,currentlock(a5)
;	jsr	CurrentDir(a6)

	move.l	(a0),d1
	move.l	startcdnameD(a5),d2
	moveq	#108-1,d3
	move.l	dosbas(a5),a6
	jsr	NameFromLock(a6)


;=== load program's icon
	move.l	a2,a0
	move.l	iconbas(a5),a6
	jsr	GetDiskObject(a6)
	move.l	d0,programicon(a5)
	beq.s	.wberr

	move.l	d0,a0
	cmp.b	#3,$30(a0)			; do_Type ?= WBTOOL
	bne.s	.wberr

;=== Retrieve tooltypes
	move.l	$36(a0),a3			; do_Tooltypes
	lea	.tooltypes(pc),a2
	bra.s	.ttjin
.tooltypeloop
	lea	-2(a2,d0.w),a1
	move.l	a3,a0
	jsr	FindToolType(a6)
	move.w	(a2)+,d1
	move.l	d0,(a5,d1.w)			; may be NULL
.ttjin	move.w	(a2)+,d0
	bne.s	.tooltypeloop

.wberr



	ELSE
;=== not executable (launched from assembler)


;=== set CurrentDir
;	lea	.ownpath(pc),a0
;	move.l	a0,d1
;	moveq	#-2,d2
;	move.l	dosbas(a5),a6
;	jsr	Lock(a6)
;	move.l	d0,startcd(a5)
;	beq	.neg

;	lea	asm1_cd(pc),a0
;	move.l	a0,d1
;	move.l	#256,d2
;	jsr	GetCurrentDirName(a6)
;	tst.l	d0
;	bne.s	.cdok
;	sf	asm1_cd
;.cdok

;	move.l	mytask(a5),a0
;	move.l	$5c+$3c(a0),d1

	lea	.ownpath(pc),a0
;	jsr	DoCDJ(a5)


	move.l	startcdnameD(a5),a1
	COPYTILLZERO


;	moveq	#108,d2
;	move.l	dosbas(a5),a6
;	jsr	GetCurrentDirName(a6)
;	tst.l	d0
;	bne.s	.cdok2
;	move.l	startcdnameD(a5),a0
;	clr.b	(a0)
;.cdok2

	bra.s	.further


.ownpath
	dc.b	'mt:',0
	even


	ENDC



.further
	move.l	prefsfile(a5),d1
	beq.s	.def
	move.l	dosbas(a5),a6
	jsr	FilePart(a6)
	move.l	d0,-(sp)

	lea	rt_prefs_path(a5),a1
	move.l	prefsfile(a5),a0
	sub.l	a0,d0
	beq.s	.zero
	subq.l	#1,d0
.copypath
	move.b	(a0)+,(a1)+
	dbeq	d0,.copypath
.zero	clr.b	(a1)+

	move.l	(sp)+,a0
	bra.s	.copyprefs

.def
	move.l	startcdnameD(a5),a0
	lea	rt_prefs_path(a5),a1
	COPYTILLZERO

	lea	prefsname_def(pc),a0

.copyprefs

	lea	rt_prefs_name(a5),a1
	COPYTILLZERO



	IFNE	keyfile_active
	jsr	decode_add_subJ(a5)
	ENDC



	POSITIV
.neg	NEGATIV





;=== Tooltypes strings + structure , CLI-template

.tooltypes
	dr.w	.tt_prefs
	dc.w	prefsfile

	dr.w	.tt_iconify
	dc.w	iconify

;	dr.w	.tt_maxtracks
;	dc.w	maxtracks_ptr

	dc.w	0



.tt_prefs	dc.b	'PREFS',0
.tt_iconify	dc.b	'HIDE',0

.template	dc.b	'PREFS/K,HIDE/S',0

		even




make_maxtracks	; d0 = new initial value for maxtracks
	move.l	#max_maxtracks,d1	; check maximum
	cmp.l	d1,d0
	bhi.s	.take3
	move.l	displayed_tracks(a5),d1	; check minimum
	cmp.l	d1,d0
	bcc.s	.take4
.take3	move.l	d1,d0
.take4	;move.l	d0,maxtracks_def(a5)
	bra	PutMaxtracks






check_args_and_tooltypes

	; Preferences- and Hide-tooltypes don't need to be tested.


;	lea	maxtracks_ptr(a5),a0
;	bsr.s	.get_numeric_arg
;	beq.s	.nope1
;	move.l	d0,d1
;	bsr.s	make_maxtracks
;.nope1

;	move.l	serdev_ptr(a5),d0		; init serial device name
;	beq.s	.nodev
;	move.l	d0,a0
;	lea	serialname(a5),a1
;	COPYTILLZERO
;.nodev
;
;	lea	serunit_ptr(a5),a0		; init serial device unit number
;	bsr.s	.get_numeric_arg
;	beq.s	.nounit
;	move.l	d1,serialunit(a5)
;.nounit


	IFNE	keyfile_active
	jsr	decode_add_bitchangeJ(a5)
	ENDC


	rts



	IFEQ	1

.get_numeric_arg	; a0=arg/tooltype entry
			; returns: d1=numeric value of that arg/tooltype

	tst.l	wbenchmsg(a5)
	bne.s	.fromwb
	move.l	(a0),d0
	beq.s	.nega
	move.l	d0,a0
	move.l	(a0),d1
.posi	POSITIV
.nega	NEGATIV

.fromwb	move.l	(a0),d0
	beq.s	.nega
	move.l	d0,a0
	jsr	getdecJ(a5)
	beq.s	.nega
	bra.s	.posi

	ENDC



free_args
	IFNE	executable

	move.l	rdargs(a5),d1
	beq.s	.noargs
	clr.l	rdargs(a5)
	move.l	dosbas(a5),a6
	jsr	FreeArgs(a6)
.noargs

	move.l	programicon(a5),d0
	beq.s	.noicon
	clr.l	programicon(a5)
	move.l	d0,a0
	move.l	iconbas(a5),a6
	jsr	FreeDiskObject(a6)
.noicon



;=== Unlock current directory
;	move.l	startcd(a5),d1
;	beq.s	.nocd
;	move.l	dosbas(a5),a6
;	jsr	CurrentDir(a6)
;.nocd

;	move.l	startcdnameD(a5),a0
;	tst.b	(a0)
;	beq.s	.nocd
;	jsr	DoCDJ(a5)
;.nocd

	ELSE


;	move.l	startcd(a5),d1
;	beq.s	.norm2
;	move.l	dosbas(a5),a6
;	jsr	UnLock(a6)
;	clr.l	startcd(a5)
;.norm2
;	lea	asm1_cd(pc),a0
;	tst.b	(a0)
;	beq.s	.nocd
;	move.l	a0,d1
;	move.l	dosbas(a5),a6
;	jsr	SetCurrentDirName(a6)
;.nocd

;	move.l	mytask(a5),a0
;	move.l	asm1_cd,d0
;	beq.s	.noasm1
;	move.l	d0,$5c+$3c(a0)
;.noasm1

	ENDC


;	move.l	currentlock(a5),d1
;	beq.s	.norm8
;	move.l	dosbas(a5),a6
;	jsr	UnLock(a6)
;	clr.l	currentlock(a5)
;.norm8

	rts


	IFEQ	executable
asm1_cd	dc.l	0
	ENDC



dos_error
	move.l	dosbas(a5),a6
	jsr	IoErr(a6)
	move.l	d0,d1
	moveq	#0,d2
	jmp	PrintFault(a6)




;==============================================================
;
;  Bitmap fr Redrawpattern bereitstellen
;
;==============================================================

InitBitmaps


	IFNE	keyfile_active
	lea	keybas+4(a5),a0
	move.l	-(a0),d0
	beq.s	.nokey
	move.l	d0,a6
	lea	remapper_keyD(a5),a0
	move.l	toolskeyTabD(a5),a1
	moveq	#remapper_key_id,d0
	jsr	keyFixGadget(a6)
.nokey
	ENDC



	IFNE	keyfile_active
	move.l	keybas(a5),d0
	beq.s	.nokey2
	move.l	d0,a6
	lea	midifilter_keyD(a5),a0
	move.l	toolskeyTabD(a5),a1
	moveq	#midifilter_key_id,d0
	jsr	keyFixGadget(a6)
.nokey2
	ENDC



	POSITIV
;.neg	NEGATIV



create_multtab_w	; a0=^multtab, d2.w=ysize, a1=^bitmap

;	IFEQ	mc68020
;	move.w	d2,d0
;	add.w	d0,d0
;	lea	(a0,d0.w),a0
;	ELSE
;	lea	(a0,d2.w*2),a0
;	ENDC
	move.l	a0,-(sp)

	move.l	a1,a0
	bsr.s	get_bitmap_width

	move.l	(sp)+,a0
	moveq	#0,d1
	subq.w	#1,d2
.multloop
	move.w	d1,(a0)+
	add.w	d0,d1
	dbf	d2,.multloop

	rts



create_multtab_l	; a0=^multtab, d2.w=ysize, a1=^bitmap

;	IFEQ	mc68020
;	move.w	d2,d0
;	lsl.w	#2,d0
;	lea	(a0,d0.w),a0
;	ELSE
;	lea	(a0,d2.w*4),a0
;	ENDC
	move.l	a0,-(sp)

	move.l	a1,a0
	bsr.s	get_bitmap_width

	move.l	(sp)+,a0
	moveq	#0,d1
	subq.w	#1,d2
.multloop
	move.l	d1,(a0)+
	add.l	d0,d1
	dbf	d2,.multloop

	rts



get_bitmap_width	; a0 = ^bitmap
			; returns: d0.l = width in bytes

	tst.b	kick30(a5)
	bne.s	.ks30
	moveq	#0,d0
	move.w	(a0),d0
	lsl.l	#3,d0
	rts
.ks30	moveq	#8,d1		; BMA_WIDTH in pixels
	move.l	gfxbas(a5),a6
	jsr	GetBitMapAttr(a6)
	tst.b	cgx_bitmaps(a5)
	bne.s	.cgx
	lsr.l	#3,d0
.cgx	rts




GetBitmap	; d0=width, d1=height, d2=depth
		; zurck: a0=^bitmap or NULL

	movem.l	d0-d3,-(sp)

	tst.b	kick30(a5)
	bne.s	.kick30

;=== Initroutine fr pre-V39

	moveq	#$28,d0
	move.l	#$10001,d1
	bsr	MyAllocVec
	move.l	d0,a3
	tst.l	d0
	beq.s	.neg

	move.l	d0,a0
	move.l	8(sp),d0
	move.l	(sp),d1
	move.l	4(sp),d2
	move.l	gfxbas(a5),a6
	jsr	InitBitmap(a6)

	lea	8(a3),a2
	move.l	8(sp),d2
.bitmaploop
	move.l	(sp),d0
	move.l	4(sp),d1
	jsr	AllocRaster(a6)
	move.l	d0,(a2)+
	beq.s	.neg
	subq.l	#1,d2
	bne.s	.bitmaploop


.neg	move.l	a3,a0
.back	movem.l	(sp)+,d0-d3
	rts

.kick30
	movem.l	(sp),d0-d2
	suba.l	a0,a0
	moveq	#17,d3		; BMB_CLEAR | BMB_MINPLANES
	tst.b	cgx_bitmaps(a5)
	beq.s	.nocgx
	moveq	#8,d2
;	bset	#7,d3		; BMB_SPECIALFMT | PIXFMT_LUT8
	move.l	Scr(a5),a0
	move.l	$54+4(a0),a0	; use as friend bitmap
.nocgx
	move.l	gfxbas(a5),a6
	jsr	AllocBitMap(a6)
	move.l	d0,a0
	bra.s	.back





PrepareTrackdisplayBitmap	; d1.l = channelwindow number
				; d0.w = channel (1-16)
				; returns: pos/neg

				rsreset
				rs.l	1	; channelwindow*4
.sp_channelwindow		rs.l	1
.sp_displayed_tracks		rs.l	1
.sp_lines_in_td_half_m10	rs.l	1
.sp_rp				rs.b	100
.sp_sizeof			rs.l	0


	lea	-.sp_sizeof(sp),sp

	move.l	d1,.sp_channelwindow(sp)
	lsl.l	#2,d1
	move.l	d1,(sp)

	jsr	get_channelblock_chanJ(a5)

	move.l	chan_lines_in_td_half(a0),d0
	mulu	#10,d0
	move.l	d0,.sp_lines_in_td_half_m10(sp)
	move.l	chan_displayed_tracks(a0),.sp_displayed_tracks(sp)



; First free the old bitmaps.
	lea	tdbitmap_chans(a5),a0
	adda.l	(sp),a0
	bsr	UngetBitmap
	lea	emptybitmap_chans(a5),a0
	adda.l	(sp),a0
	bsr	UngetBitmap


; calculate the width in pixels
	move.l	.sp_displayed_tracks(sp),d0
	mulu	#tracktextd,d0
	moveq	#tracktextx,d1
	add.l	d1,d0
	lsl.l	#3,d0
	move.l	d0,d5

	lea	tdbitmap_width_chans(a5),a0
	adda.l	(sp),a0
	move.l	d0,(a0)


; calculate the height:
;   lines in the upper/lower half, mid-row, black/white lines
;	moveq	#(lines_in_td_half*10+1)*2+11+6,d1

	move.l	.sp_lines_in_td_half_m10(sp),d1
	add.l	d1,d1
; top frame, upper middle sepline, midspace, lower middle sepline, bottom frame
	moveq	#2+2+10+2+2,d2
	add.l	d2,d1

	lea	tdbitmap_height_chans(a5),a0
	adda.l	(sp),a0
	move.l	d1,(a0)
	move.l	d1,d4


	moveq	#2,d2	; depth
	bsr	GetBitmap
	lea	tdbitmap_chans(a5),a1
	adda.l	(sp),a1
	move.l	a0,(a1)
	beq	.neg



; Allocate empty bitmap for reseting the trackdisplay bitmap
	move.l	d5,d0
	move.l	d4,d1
	moveq	#2,d2
	bsr	GetBitmap
	lea	emptybitmap_chans(a5),a1
	adda.l	(sp),a1
	move.l	a0,(a1)
	beq	.neg



	move.l	a0,a4
	bsr	get_bitmap_width

	lea	tdbitmap_bpr_chans(a5),a0
	adda.l	(sp),a0
	move.l	d0,(a0)



; d5 = gfx-width in pixels, d4 = gfx-height, a4 = ^bitmap



; Create multiplication table.

	move.l	.sp_channelwindow(sp),d0
	bsr	FreeTrackdisplayMulttab

	move.l	d4,d0
	lsl.l	#2,d0
	moveq	#1,d1
	bsr	MyAllocVec
	lea	tdbitmap_multtab_chans(a5),a0
	adda.l	(sp),a0
	move.l	d0,(a0)
	beq	.neg

	move.l	a4,a1
	move.l	d0,a0
	move.l	d4,d2
	bsr	create_multtab_l




	lea	.sp_rp(sp),a2
	move.l	a2,a1
	move.l	gfxbas(a5),a6
	jsr	InitRastPort(a6)
	move.l	a4,4(a2)

; colour white

	moveq	#2,d0
	move.l	a2,a1
	jsr	SetAPen(a6)

; top line

	moveq	#4,d0
	moveq	#0,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d5,d0
	subq.l	#4,d0
	move.l	d0,d2
	moveq	#0,d1
	move.l	a2,a1
	jsr	Draw(a6)

; upper midrow (white)

	moveq	#2+1,d1
	add.l	.sp_lines_in_td_half_m10(sp),d1
	move.l	d1,d3
	moveq	#4,d0
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d1
	move.l	d2,d0
	move.l	a2,a1
	jsr	Draw(a6)

; lower midrow (white)

	moveq	#2+2+10+1,d1
	add.l	.sp_lines_in_td_half_m10(sp),d1
	move.l	d1,d3
	moveq	#4,d0
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d1
	move.l	d2,d0
	move.l	a2,a1
	jsr	Draw(a6)

; first vertical line (white)

	moveq	#4,d0
	moveq	#0,d1
	move.l	a2,a1
	jsr	Move(a6)

	moveq	#4,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	moveq	#5,d0
	moveq	#0,d1
	move.l	a2,a1
	jsr	Move(a6)

	moveq	#5,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)



; colour black

	moveq	#1,d0
	move.l	a2,a1
	jsr	SetAPen(a6)

; bottom line

	move.l	d4,d1
	subq.l	#1,d1
	moveq	#4,d0
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d4,d1
	subq.l	#1,d1
	move.l	d2,d0
	move.l	a2,a1
	jsr	Draw(a6)

; upper midrow (black)

	moveq	#2,d1
	add.l	.sp_lines_in_td_half_m10(sp),d1
	move.l	d1,d3
	moveq	#4,d0
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d1
	move.l	d2,d0
	move.l	a2,a1
	jsr	Draw(a6)

; lower midrow (black)

	moveq	#2+2+10,d1
	add.l	.sp_lines_in_td_half_m10(sp),d1
	move.l	d1,d3
	moveq	#4,d0
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d1
	move.l	d2,d0
	move.l	a2,a1
	jsr	Draw(a6)

; last vertical line (black)

	move.l	d5,d0
	subq.l	#4,d0
	moveq	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d5,d0
	subq.l	#4,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.l	d5,d0
	subq.l	#5,d0
	moveq	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d5,d0
	subq.l	#5,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)




; Draw the column separation lines.

	move.l	.sp_lines_in_td_half_m10(sp),d0
	moveq	#2+1,d6
	add.l	d0,d6
	moveq	#2+2+10+1,d7
	add.l	d0,d7

	moveq	#bpmtextx-1,d0
	bsr.s	.draw_separation_lines

	moveq	#presettextx-1,d0
	bsr.s	.draw_separation_lines

	moveq	#cstextx-1,d0
	bsr.s	.draw_separation_lines

	moveq	#tracktextx-1,d0
	move.l	.sp_displayed_tracks(sp),d5
	subq.l	#1,d5
.tracksloop
	bsr.s	.draw_separation_lines
	addq.l	#tracktextd,d0
	dbf	d5,.tracksloop





	IFEQ	1

; Now draw the top line and the above mid-lines.

	movem.l	8(a4),a0-a1	; pointers to the two bitplanes

; pointers to the above mid-row lines
;	moveq	#1+(lines_in_td_half*10+1),d0

	move.l	.sp_lines_in_td_half_m10(sp),d0
	addq.l	#2,d0

	IFEQ	mc68020
	add.l	d0,d0
	move.w	(a6,d0.l),d0
	ELSE
	move.w	(a6,d0.l*2),d0
	ENDC
	lea	(a0,d0.l),a2
	lea	(a1,d0.l),a3

	move.b	#%00000000,(a0)+	; white top line
	move.b	#%00001111,(a1)+
	move.b	#%00000000,(a2,d3.l)	; white midrow-2
	move.b	#%00001111,(a3,d3.l)
	move.b	#%00001111,(a2)+	; black midrow-1
	move.b	#%00000000,(a3)+

	move.w	d5,d0
	subq.w	#3,d0
.loop1	sf	(a0)+		; white top line
	st	(a1)+
	sf	(a2,d3.l)	; white midrow-2
	st	(a3,d3.l)
	st	(a2)+		; black midrow-1
	sf	(a3)+
	dbf	d0,.loop1

	move.b	#%00000000,(a0)+	; white top line
	move.b	#%11110000,(a1)+
	move.b	#%00000000,(a2,d3.l)	; white midrow-2
	move.b	#%11110000,(a3,d3.l)
	move.b	#%11110000,(a2)+	; black midrow-1
	move.b	#%00000000,(a3)+



; Draw the bottom mid-lines and the total bottom line.

	movem.l	8(a4),a0-a1	; pointers to the two bitplanes

; pointers to the total bottom line
	move.l	d4,d0
	subq.l	#1,d0
	IFEQ	mc68020
	add.l	d0,d0
	move.w	(a6,d0.l),d0
	ELSE
	move.w	(a6,d0.l*2),d0
	ENDC
	lea	(a0,d0.l),a2
	lea	(a1,d0.l),a3

; pointers to the bottom mid-row lines
;	moveq	#1+(lines_in_td_half*10+1)+2+11,d0

	move.l	.sp_lines_in_td_half_m10(sp),d0
	moveq	#15,d1
	add.l	d1,d0

	IFEQ	mc68020
	add.l	d0,d0
	move.w	(a6,d0.l),d0
	ELSE
	move.w	(a6,d0.l*2),d0
	ENDC
	adda.l	d0,a0
	adda.l	d0,a1

	move.b	#%00000000,(a0,d3.l)	; white midrow-2
	move.b	#%00001111,(a1,d3.l)
	move.b	#%00001111,(a0)+	; black midrow-1
	move.b	#%00000000,(a1)+
	move.b	#%00001111,(a2)+	; black bottom line
	move.b	#%00000000,(a3)+

	move.w	d5,d0
	subq.w	#3,d0
.loop2	sf	(a0,d3.l)	; white midrow-2
	st	(a1,d3.l)
	st	(a0)+		; black midrow-1
	sf	(a1)+
	st	(a2)+		; black bottom line
	sf	(a3)+
	dbf	d0,.loop2

	move.b	#%00000000,(a0,d3.l)	; white midrow-2
	move.b	#%11110000,(a1,d3.l)
	move.b	#%11110000,(a0)+	; black midrow-1
	move.b	#%00000000,(a1)+
	move.b	#%11110000,(a2)+	; black bottom line
	move.b	#%00000000,(a3)+





; Draw the column separation lines.

	move.l	.sp_lines_in_td_half_m10(sp),d6
	move.l	d6,d7
	addq.l	#3,d6
	moveq	#16,d0
	add.l	d0,d7

	moveq	#bpmtextx-1,d0
	bsr.s	.draw_separation_lines

	moveq	#presettextx-1,d0
	bsr.s	.draw_separation_lines

	moveq	#cstextx-1,d0
	bsr.s	.draw_separation_lines


	moveq	#tracktextx-1,d0
	move.l	.sp_displayed_tracks(sp),d2
	subq.l	#1,d2
.tracksloop
	bsr.s	.draw_separation_lines
	addq.l	#tracktextd,d0
	dbf	d2,.tracksloop



; Draw the leftmost and rightmost lines.

	movem.l	8(a4),a0-a1	; pointers to the two bitplanes
	adda.l	d3,a0
	adda.l	d3,a1
	lea	-1(a0,d5.l),a2
	lea	-1(a1,d5.l),a3
	move.l	d4,d0
	subq.w	#3,d0
.mostloop
	and.b	#%00000011,(a0)
	or.b	#%00001100,(a1)
	or.b	#%00110000,(a2)
	and.b	#%11000000,(a3)
	adda.l	d3,a0
	adda.l	d3,a1
	adda.l	d3,a2
	adda.l	d3,a3
	dbf	d0,.mostloop

	ENDC



	lea	.sp_sizeof(sp),sp
	POSITIV

.neg	move.l	.sp_channelwindow(sp),d0
	bsr	FreeTrackdisplayBitmap
	lea	.sp_sizeof(sp),sp
	NEGATIV




.draw_separation_lines	; d0.l = x-offset in bytes, a2 = rp, d4 = bitmap height,
			; d6/d7 = y-offsets to skip


	move.l	d0,-(sp)

	lsl.l	#3,d0
	move.l	d0,d3

; draw the white line (2 pixels wide)

	moveq	#2,d0
	jsr	SetAPen(a6)

	move.l	d3,d0
	addq.l	#4,d0
	moveq	#0,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d0
	addq.l	#4,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.l	d3,d0
	addq.l	#5,d0
	moveq	#0,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d3,d0
	addq.l	#5,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

; draw the black line (2 pixels wide), with two skips

	moveq	#1,d0
	move.l	a2,a1
	jsr	SetAPen(a6)

	move.l	d3,d2
	addq.l	#2,d2
	bsr.s	.draw_one_column_line

	move.l	d3,d2
	addq.l	#3,d2
	bsr.s	.draw_one_column_line

	move.l	(sp)+,d0
	rts


.draw_one_column_line	; a2 = rp, d2 = x-pos, d4 = bm height, d6/d7 = y-offsets to skip

	move.l	d2,d0
	moveq	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d2,d0
	move.l	d6,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.l	d2,d0
	move.l	d6,d1
	addq.l	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d2,d0
	move.l	d7,d1
	subq.l	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.l	d2,d0
	move.l	d7,d1
	addq.l	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.l	d2,d0
	move.l	d4,d1
	subq.l	#1,d1
	move.l	a2,a1
	jmp	Draw(a6)





	IFEQ	1

.draw_separation_lines	; d0.l = x-offset in bytes

	movem.l	8(a4),a0-a1	; pointers to the two bitplanes
	adda.l	d0,a0
	adda.l	d0,a1

	adda.l	d3,a0		; start at the second row
	adda.l	d3,a1

	moveq	#1,d1
.yloop
	cmp.w	d4,d1
	beq.s	.yout
	cmp.w	d6,d1
	beq.s	.yskip
	cmp.w	d7,d1
	beq.s	.yskip
	or.b	#%00110000,(a0)	; black
	and.b	#%11001111,(a1)
	and.b	#%11110011,(a0)	; white
	or.b	#%00001100,(a1)
.yskip	adda.l	d3,a0
	adda.l	d3,a1
	addq.w	#1,d1
	bra.s	.yloop
.yout
	rts

	ENDC



FreeTrackdisplayBitmap	; d0.l = channelwindow number

	lsl.l	#2,d0
	move.l	d0,-(sp)

	lea	tdbitmap_chans(a5),a0
	adda.l	d0,a0
	bsr.s	UngetBitmap
	lea	emptybitmap_chans(a5),a0
	adda.l	(sp),a0
	bsr.s	UngetBitmap
	move.l	(sp)+,d0
	lsr.l	#2,d0
;	bsr.s	FreeTrackdisplayMulttab

FreeTrackdisplayMulttab	; d0.w = channelwindow number
	lea	tdbitmap_multtab_chans(a5),a0
	lsl.w	#2,d0
	adda.w	d0,a0
	bra	MyFreeVector




UngetBitmap	; a0=^bitmap

	tst.b	kick30(a5)
	bne.s	.kick30

	move.l	(a0),d0
	beq.s	.nobitmap

	move.l	a0,-(sp)
	move.l	d0,a2
	move.w	(a2)+,d2		; width in bytes
	lsl.w	#3,d2
	move.w	(a2)+,d3		; height
	move.b	1(a2),d4		; depth
	addq.w	#4,a2

	move.l	gfxbas(a5),a6

.bitmaploop
	move.l	(a2)+,d0
	beq.s	.noraster
	move.l	d0,a0
	move.w	d2,d0
	move.w	d3,d1
	jsr	FreeRaster(a6)
.noraster
	subq.b	#1,d4
	bne.s	.bitmaploop

	move.l	(sp)+,a0
	bra	MyFreeVector


.kick30
	move.l	(a0),d0
	beq.s	.nobitmap
	clr.l	(a0)
	move.l	d0,a0
	move.l	gfxbas(a5),a6
	jsr	FreeBitmap(a6)
.nobitmap
	rts









	IFEQ	1

DrawRect	; d0-d3 = left/top/width/height, a2 = rp

	subq.w	#8,sp
	movem.w	d0-d1,(sp)
	add.w	d2,d0
	subq.w	#1,d0
	add.w	d3,d1
	subq.w	#1,d1
	movem.w	d0-d1,4(sp)


;=== black border behind
	move.l	a2,a1
	jsr	set_black_and_jam1J(a5)

	move.w	(sp),d0
	addq.w	#1,d0
	move.w	2(sp),d1
	addq.w	#1,d1
	move.l	a2,a1
	jsr	Move(a6)

	move.w	4(sp),d0
	move.w	2(sp),d1
	addq.w	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	4(sp),d0
	move.w	6(sp),d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	(sp),d0
	addq.w	#1,d0
	move.w	6(sp),d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	(sp),d0
	addq.w	#1,d0
	move.w	2(sp),d1
	addq.w	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)



;=== white border in front
	move.l	a2,a1
	jsr	set_white_and_jam1J(a5)

	move.w	(sp),d0
	move.w	2(sp),d1
	move.l	a2,a1
	jsr	Move(a6)

	move.w	4(sp),d0
	subq.w	#1,d0
	move.w	2(sp),d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	4(sp),d0
	subq.w	#1,d0
	move.w	6(sp),d1
	subq.w	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	(sp),d0
	move.w	6(sp),d1
	subq.w	#1,d1
	move.l	a2,a1
	jsr	Draw(a6)

	move.w	(sp),d0
	move.w	2(sp),d1
	move.l	a2,a1
	jsr	Draw(a6)

	addq.w	#8,sp
	rts

	ENDC



;==============================================================
;
;  Initialize rastport for patternfont
;
;==============================================================

PerformPatternfont
	subq.l	#8,sp		; local stack, for TextAttr structure

	tst.b	pattfontname(a5)
	bne.s	.skipdef
;=== Default-patternfontname kopieren
	move.l	fontname_defD(a5),a0
	lea	pattfontname(a5),a1
	COPYTILLZERO
	clr.b	pattfontstyle(a5)	; Default = NORMAL
	move.b	#$41,pattfontflags(a5)	; Default = ROMFONT!DESIGN
.skipdef

	lea	pattfontname(a5),a0
	move.l	a0,(sp)
	move.w	#8,4(sp)
	move.b	pattfontstyle(a5),6(sp)
	move.b	pattfontflags(a5),7(sp)
	move.l	sp,a0
	move.l	gfxbas(a5),a6
	jsr	OpenFont(a6)
	tst.l	d0
	bne.s	.gotit
	move.l	sp,a0
	move.l	dfbas(a5),a6
	jsr	OpenDiskFont(a6)
	tst.l	d0
	beq	.neg

.gotit
	move.l	d0,-(sp)
	move.l	d0,a0
	move.w	$1a(a0),d4	; y-baseline
	moveq	#8,d3		; Calculate the x-offset which is
	sub.w	$18(a0),d3	; added to each char. This will center
	lsr.w	#1,d3		; the char into its 8 pixels.

	move.l	patternfont_rp(a5),a1
	move.l	gfxbas(a5),a6
	jsr	SetFont(a6)

	moveq	#0,d0			; clear bitmap, in case our
	move.l	patternfont_rp(a5),a1	; font has xsize < 8, to be clean.
	jsr	SetRast(a6)

	move.l	patternfont_rp(a5),a1
	move.w	pr_screendepth(a5),d1
	lsl.w	d1,d0
	subq.w	#1,d0
	jsr	SetAPen(a6)


;=== Now we will draw every single character.
;=== So we make sure that each char begins at a byte-offset position.

	lea	pfont_initstring+pfont_initstring_len(pc),a2
	add.w	#(pfont_initstring_len-1)*8,d3
.characterloop
	subq.w	#1,a2

	move.w	d3,d0
	move.w	d4,d1
	move.l	patternfont_rp(a5),a1
	move.l	gfxbas(a5),a6
	jsr	Move(a6)
	move.l	a2,a0
	moveq	#1,d0
	move.l	patternfont_rp(a5),a1
	jsr	Text(a6)

	subq.w	#8,d3
	bcc.s	.characterloop


	move.l	(sp)+,a1
	jsr	CloseFont(a6)

	addq.w	#8,sp
	POSITIV

.neg	addq.w	#8,sp
	NEGATIV



pfont_initstring
	dc.b	' !"#$%&''()*+,-./0123456789:;<=>?@'
	dc.b	'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
pfont_initstring_len = *-pfont_initstring
	even





FreeSongs

;=== Flush current song
	move.l	currentsong(a5),d2
	jsr	add_replace_songJ(a5)
	beq.s	.done


;=== Now free all songs and data associated

	move.l	song_root(a5),a2
.songloop
	move.l	a2,-(sp)
	move.l	sn_patterntab(a2),patterntab(a5)
	move.l	sn_patterntablen(a2),patterntablen(a5)
	move.l	sn_positionsA(a2),positionsA(a5)
;	move.l	sn_active_cs(a2),active_csources(a5)
	move.l	sn_length(a2),length(a5)

	bsr	FreePatternData


	move.l	sn_sysex_msgs(a2),sysex_msgs(a5)
	movem.l	sn_sysex_listroot(a2),d0-d2
	movem.l	d0-d2,sysex_listroot(a5)
	jsr	FreeSysexMessagesJ(a5)


	move.l	(sp)+,a1
	move.l	(a1),a2
	bsr	MyFreeVec

	move.l	a2,d0
	bne.s	.songloop

.done	rts




	IFNE	keyfile_active

decode_keyfile
	lea	4(a5),a0
	move.l	keybas-4(a0),d0
	beq.s	.nokey

	move.l	d0,a0
	move.l	keylib_seglist(a0),d0
	lsl.l	#2,d0
	addq.l	#4,d0
	move.l	d0,a0
	lea	lib_checksums_offset(a0),a1
	move.l	a1,checksums_start(a5)
	lea	lib_keycode_offset(a0),a0
	move.l	a0,keycode_start(a5)

	move.w	#keycode_length+checksums_sizeof-1,d3
.decodeloop
	move.b	(a0),d0
	sub.b	d3,d0
	eor.b	d3,d0
	rol.b	d3,d0
	move.b	d0,(a0)+
	dbf	d3,.decodeloop


	move.l	(a5),a6
	jsr	CacheClearU(a6)

.nokey	rts




FreeKeyfile
	move.l	keybas(a5),d0
	beq.s	.rts
	move.l	d0,a1
	move.l	(a5),a6
	jsr	CloseLibrary(a6)
	jsr	Forbid(a6)
	move.l	keybas(a5),a1
	jsr	RemLibrary(a6)
	jsr	Permit(a6)
	clr.l	keybas(a5)
.rts	rts



word_checksum_test
	ext.l	d2
long_checksum_test
	tst.l	d2
	bne.s	FreeKeyfile
	rts


	ENDC




FreeSysExMessages

	moveq	#GD_sysexlist,d1
	jsr	ResetListviewSysexJ(a5)

	move.l	sysex_listroot(a5),a2
	move.l	sysex_msgs(a5),d2
	bra.s	.jin
.findloop
	move.l	a2,a1
	move.l	(a2),a2
	bsr	MyFreeVec
.jin	subq.l	#1,d2
	bcc.s	.findloop

InitSysexMessages
	lea	sysex_listroot(a5),a1
	lea	4(a1),a0
	move.l	a0,(a1)
	move.l	a0,8(a1)

	clr.l	sysex_msgs(a5)
	clr.l	active_sysex(a5)
	rts





load_controlsources
	suba.l	a0,a0
	lea	.csfilename(pc),a1
	jsr	CompleteFilenameJ(a5)
	move.l	d1,a2
	lea	controlsources_file(a5),a3
	jsr	loadfile_publicJ(a5)
	beq.s	.default

	bsr	.cs_plausi
	beq.s	.file_error


;=== Fill the strings table

	move.l	(a3),a3
	move.l	csources_stringsD(a5),a1
	move.l	panic_codesD(a5),a2
	moveq	#$0a,d5
	moveq	#127,d3
.fillloop
	addq.w	#5,a3
	move.l	a3,a0
	addq.w	#3,a3
	clr.b	(a3)
	jsr	getdecJ(a5)
	beq.s	.file_error
	move.b	#' ',(a3)
	move.b	d1,(a2)+
	move.l	a3,(a1)+

;=== put the abbreviation chars over the panic-value chars
	lea	-4(a3),a0
	move.l	a3,a4
	move.b	-(a0),-(a4)
	move.b	-(a0),-(a4)
	move.b	-(a0),-(a4)
	move.b	-(a0),-(a4)

.lfloop	cmp.b	(a3)+,d5
	bne.s	.lfloop

	clr.b	-1(a3)
	dbf	d3,.fillloop

	rts




.file_error
	move.w	#loc_cserrorbody,d0
	move.w	#loc_checkdiz,d1
	jsr	EZrequestJ(a5)

.default
	move.l	default_csourcesD(a5),a3
	move.l	csources_stringsD(a5),a1
	moveq	#127,d3
.fillloop2

	addq.w	#4,a3
	move.l	a3,(a1)+

.lflop2	tst.b	(a3)+
	bne.s	.lflop2

	dbf	d3,.fillloop2

	move.l	default_panic_codesD(a5),panic_codesD(a5)

	rts




.csfilename	dc.b	'Controlsources',0
		even


.cs_plausi	; a3 = ^filestruct

;=== count linefeeds

	move.l	(a3),a0
	move.l	4(a3),d1
	moveq	#$0a,d0
	moveq	#-128,d2
	moveq	#0,d3
	bra.s	.jin
.plausiloop
	cmp.b	(a0)+,d0
	bne.s	.nolf
	addq.l	#1,d2
	moveq	#10,d4		; 10 chars per line is minimum
	cmp.l	d4,d3
	bcs.s	.nope
	moveq	#0,d3
	bra.s	.lfcont
.nolf	addq.l	#1,d3
.lfcont
.jin	subq.l	#1,d1
	bcc.s	.plausiloop

	tst.l	d2
	bne.s	.nope

	POSITIV
.nope	NEGATIV




free_controlsources
	lea	controlsources_file(a5),a3
	jmp	unloadfileJ(a5)






load_quickloader
	suba.l	a0,a0
	lea	quickfilename(pc),a1
	jsr	CompleteFilenameJ(a5)
	move.l	d1,a2
	lea	quickload_file(a5),a3
	jsr	loadfile_publicJ(a5)
	beq.s	.default

	bsr.s	.plausi
	bne.s	.plausi_ok

.default
	lea	.defaultfile(pc),a2
	bra.s	.defcont

.plausi_ok
	move.l	(a3),a2

.defcont

	move.w	#loc_nosongname,d0
	jsr	getcatstringJ(a5)
	move.l	a1,a6

	move.l	MTmainMquick1D(a5),a4
	moveq	#4,d2
.defaultloop

	tst.b	(a2)
	bne.s	.filled

	addq.w	#1,a2
	move.l	a6,a0
	move.l	a4,a1
	sf	(a1)+
	COPYTILLZERO
	bra.s	.copydone

.filled	move.l	a2,a0
	move.l	a4,a1
	st	(a1)+
	COPYTILLZERO
	move.l	a0,a2
.copydone

	lea	quickload_len(a4),a4
	dbf	d2,.defaultloop

	jmp	unloadfileJ(a5)



.plausi
	move.l	(a3),a0
	move.l	a0,a1
	adda.l	4(a3),a1
	moveq	#$0a,d1
	moveq	#5,d2
	bra.s	.pin
.plausiloop
	move.b	(a0)+,d0
	cmp.b	d1,d0
	bne.s	.noadd
	clr.b	-1(a0)
	subq.l	#1,d2
	bcs.s	.nope
.noadd
.pin	cmpa.l	a1,a0
	bcs.s	.plausiloop

	tst.l	d2
	bne.s	.nope

	POSITIV
.nope	NEGATIV



.defaultfile	dcb.b	5,0
quickfilename	dc.b	'Quicksongs',0
		even





save_quickloader

	tst.b	quickloader_changed(a5)
	beq.s	.dont

;	jsr	GoStartCDJ(a5)


	move.l	MTmainMquick1D(a5),a2
	move.l	a2,a1
	move.l	a2,d3
	moveq	#4,d2
.quickloop

	move.l	a2,a0
	tst.b	(a0)+
	bne.s	.active
	addq.w	#1,a1
	bra.s	.acont
.active	COPYTILLZERO
.acont	move.b	#$0a,-1(a1)

	lea	quickload_len(a2),a2
	dbf	d2,.quickloop

	suba.l	a1,d3
	neg.l	d3


	suba.l	a0,a0
	lea	quickfilename(pc),a1
	jsr	CompleteFilenameJ(a5)

	move.l	#1006,d2
	move.l	dosbas(a5),a6
	jsr	Open(a6)
	move.l	d0,d7
	beq.s	.nofile

	move.l	d7,d1
	move.l	MTmainMquick1D(a5),a0
	move.l	a0,d2
	jsr	Write(a6)

	move.l	d7,d1
	jsr	Close(a6)
.nofile

.dont	rts




;==============================================================
;
;  Timer Device ffnen
;
;==============================================================

OpenTimer_main

	lea	TimerReply(a5),a0
	lea	TimerIO(a5),a1


OpenTimer_routine	; a0 = ^replyport pointer, a1 = ^iorequest pointer, d0 = pri

	movem.l	d0/a0-a1,-(sp)

	move.l	(a5),a6
	jsr	CreateMsgPort(a6)
	move.l	4(sp),a0
	move.l	d0,(a0)
	beq.s	.neg

	move.l	d0,a0
	moveq	#$28,d0
	jsr	CreateIORequest(a6)
	move.l	8(sp),a0
	move.l	d0,(a0)
	beq.s	.neg

	move.l	d0,a1
	move.l	(sp),d0
	move.b	d0,9(a1)		; Pri

	lea	timnam(pc),a0
	move.l	a0,$a(a1)
	moveq	#0,d0			; unit_MICROHZ
	moveq	#0,d1
	jsr	OpenDevice(a6)
	tst.b	d0
	bne.s	.neg

	lea	$c(sp),sp
	POSITIV
.neg	lea	$c(sp),sp
	NEGATIV






;==============================================================
;
;  Timer Device schlieen
;
;==============================================================

CloseTimer_main
	lea	TimerReply(a5),a0
	lea	TimerIO(a5),a1


CloseTimer_routine	; a0 = ^replyport pointer, a1 = ^iorequest pointer

	movem.l	a0-a1,-(sp)

	move.l	(a5),a6

	move.l	4(sp),a0
	move.l	(a0),d0
	beq.s	.noio
	move.l	d0,a1
	tst.l	$14(a1)
	beq.s	.nodev
	jsr	CloseDevice(a6)
.nodev

	move.l	4(sp),a1
	move.l	(a1),a0
	clr.l	(a1)
	jsr	DeleteIORequest(a6)
.noio

	move.l	(sp),a1
	move.l	(a1),d0
	beq.s	.noport
	move.l	d0,a0
	clr.l	(a1)
	jsr	DeleteMsgPort(a6)
.noport

	addq.l	#8,sp
	rts





;=== call this once the program starts up

PrepareCIA

	lea	cianam(pc),a1
	move.l	(a5),a6
	jsr	OpenResource(a6)
	move.l	d0,ciares(a5)
	beq.s	.neg

	POSITIV
.neg	NEGATIV




;=== call this to clean up, at the end of the program

;FinishCIA
;	bra	CloseTimer


